SystemOrganization addCategory: #'DotNetBridge-Abstract Tests'!
SystemOrganization addCategory: #'DotNetBridge-Basic Tests'!
SystemOrganization addCategory: #'DotNetBridge-Externals'!
SystemOrganization addCategory: #'DotNetBridge-Kernel'!
SystemOrganization addCategory: #'DotNetBridge-Plugin'!
SystemOrganization addCategory: #'DotNetBridge-Plugin Tests'!
SystemOrganization addCategory: #'DotNetBridge-Socket Tests'!
SystemOrganization addCategory: #'DotNetBridge-Tests Support'!

OldSimpleClientSocket subclass: #DotNetSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!DotNetSocket methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 09:23'!
amountInMainBuffer: maxSize

	| totalInBuffer |
	buffer ifNil: [^0].

	totalInBuffer _ buffer size - bufferPos.
	^ totalInBuffer min: maxSize! !

!DotNetSocket methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:50'!
readBytes: size

	| readBuffer amountInMainBuffer textFromBuffer bytesRead |

	amountInMainBuffer _ self amountInMainBuffer: size.

	buffer ifNil:
		[buffer _ String new.
		bufferPos _ 0].

	textFromBuffer _ buffer
		copyFrom: bufferPos + 1
		to: bufferPos + amountInMainBuffer.
	bufferPos _ bufferPos + amountInMainBuffer.

	readBuffer _ String new: size.
	readBuffer
		replaceFrom: 1
		to: amountInMainBuffer
		with: textFromBuffer.

	bytesRead _ amountInMainBuffer.
	[bytesRead < size] whileTrue:
		[bytesRead _ bytesRead + (self
			readInto: readBuffer
			startingAt: bytesRead + 1)].

	^ readBuffer! !

!DotNetSocket methodsFor: 'as yet unclassified' stamp: 'bvs 8/14/2003 13:49'!
waitForDataQueryingUserEvery: seconds

	"We're using SimpleClientSocket for its cr/lf handling, but
	keep a receiving connection open all the time and don't
	want to show messages about the server not responding."

	| gotData |
	gotData _ false.
	[gotData] whileFalse:
		[gotData _ self waitForDataUntil: (Socket deadlineSecs: seconds).
		gotData ifFalse:
			[self isConnected ifFalse:
				[self destroy.
				self error: 'server closed connection']]]! !

Error subclass: #DotNetException
	instanceVariableNames: 'dotNet remoteId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!DotNetException commentStamp: 'bvs 9/11/2003 14:04' prior: 0!
A proxy for a .NET exception.!

!DotNetException methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 08:56'!
doesNotUnderstand: aMessage

	^ dotNet
		sendMessageFrom: self
		selector: aMessage selector
		arguments: aMessage arguments! !

!DotNetException methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 08:59'!
initializeRemoteId: anId dotNet: aDotNet

	remoteId _ anId.
	dotNet _ aDotNet! !

!DotNetException methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 09:01'!
remoteId

	^remoteId! !

Error subclass: #MissingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

Object subclass: #DirectTransport
	instanceVariableNames: 'dotNetSide socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin'!

!DirectTransport class methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 13:23'!
startNew

	^ self new initializeAsClient
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:14'!
close

	socket close! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 13:24'!
createDotNetSide

	< primitive: 'primCreateDirectTransport' module: 'DirectTransportPlugin'>
	^ self primitiveFailed
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 14:58'!
createDotNetSideBasedOn: aDotNetSide

	< primitive: 'primCreateDirectTransportBasedOn' module: 'DirectTransportPlugin'>
	^ self primitiveFailed
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:11'!
createServerRequestedDotNetSideBasedOn: aDotNetSide

	< primitive: 'primCreateServerRequestedDirectTransportBasedOn' module: 'DirectTransportPlugin'>
	^ self primitiveFailed
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 14:00'!
dotNetSideControlPort

	< primitive: 'primControlPort' module: 'DirectTransportPlugin'>
	^ self primitiveFailed! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 14:30'!
dotNetSideFinishInitialization

	< primitive: 'primFinishInitialization' module: 'DirectTransportPlugin'>
	^ self primitiveFailed! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:16'!
dotNetSideReceive

	< primitive: 'primDirectTransportReceive' module: 'DirectTransportPlugin'>
	^ self primitiveFailed
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 17:03'!
dotNetSideSend: aString size: aNumber

	< primitive: 'primDirectTransportSend' module: 'DirectTransportPlugin'>
	^ self primitiveFailed
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:05'!
dotNetSideStartReceiving

	< primitive: 'primStartReceiving' module: 'DirectTransportPlugin'>
	^ self primitiveFailed! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:05'!
initializeAsClient

	| localhost |
	self createDotNetSide.
	
	Socket initializeNetwork.
	localhost _ NetNameResolver
		addressForName: 'localhost'
		timeout: 20.
	socket _ DotNetSocket new
		connectTo: localhost
		port: self dotNetSideControlPort.
	socket waitForConnectionUntil: Socket standardDeadline.

	self dotNetSideFinishInitialization.
	self dotNetSideStartReceiving.
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:05'!
initializeAsClientBasedOn: aDotNetSide

	| localhost |
	self createDotNetSideBasedOn: aDotNetSide.
	
	Socket initializeNetwork.
	localhost _ NetNameResolver
		addressForName: 'localhost'
		timeout: 20.
	socket _ DotNetSocket new
		connectTo: localhost
		port: self dotNetSideControlPort.
	socket waitForConnectionUntil: Socket standardDeadline.

	self dotNetSideFinishInitialization.
	self dotNetSideStartReceiving.
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:11'!
initializeServerRequestedBasedOn: aDotNetSide

	| localhost |
	self createServerRequestedDotNetSideBasedOn: aDotNetSide.
	
	Socket initializeNetwork.
	localhost _ NetNameResolver
		addressForName: 'localhost'
		timeout: 20.
	socket _ DotNetSocket new
		connectTo: localhost
		port: self dotNetSideControlPort.
	socket waitForConnectionUntil: Socket standardDeadline.

	self dotNetSideFinishInitialization.
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:14'!
isAlive

	^ socket isConnected
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:15'!
receive

	^ self dotNetSideReceive
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 17:17'!
send: anObject

	| aString |
	aString _ anObject asString.
	self
		dotNetSideSend: aString
		size: aString size
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 09:41'!
serverRequestedStartAnother

	^ self class new initializeServerRequestedBasedOn: dotNetSide
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:48'!
signal

	socket sendData: '!!'.
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:00'!
startAnother

	^ self class new initializeAsClientBasedOn: dotNetSide
! !

!DirectTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/5/2003 10:12'!
wait

	[socket readBytes: 1]
		on: Exception
		do:
			[:exception |
			socket isConnected
				ifTrue: [exception retry]
				ifFalse: [exception signal]]
! !

Object subclass: #DotNet
	instanceVariableNames: 'mainTransport threadTransports startedThreads rememberedObjects objectIds dotNetObjects dotNetWeakRegistry dotNetSemaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

DotNet class
	instanceVariableNames: 'instance'!

!DotNet commentStamp: 'bvs 9/11/2003 14:04' prior: 0!
A bridge to a .NET virtual machine.!

!DotNet class methodsFor: 'releasing' stamp: 'bvs 9/16/2003 11:50'!
allChangeSets

	| unsorted |
	unsorted _ ChangeSorter allChangeSets select: [:each | each name beginsWith: 'DotNetBridge'].
	
	^unsorted asSortedCollection: [:a :b | a name asInteger < b name asInteger]! !

!DotNet class methodsFor: 'examples' stamp: 'bvs 8/25/2003 13:36'!
arrayListCountExample

	"DotNet arrayListCountExample"

	| dotNet |
	[dotNet _ DotNet startNew.
	^dotNet ArrayList new count] ensure: [dotNet exitDotNet].
! !

!DotNet class methodsFor: 'examples' stamp: 'bvs 9/12/2003 09:15'!
bridgeToRubyExample

	"DotNet bridgeToRubyExample"
	"This works if you also have the Ruby bridge installed -
	please visit www.saltypickle.com/RubyDotNet for more
	information"

	| dotNet client |
	dotNet _ DotNet startNew.

	client _ dotNet Ruby getClient.
	client start.
	Transcript show: (client eval: '3 + 4').

	dotNet exitDotNet.
! !

!DotNet class methodsFor: 'releasing' stamp: 'bvs 12/4/2003 09:20'!
buildSarRelease

	"DotNet buildSarRelease"
	| dumper |
	dumper _ SARChangeSetDumper
		on: self firstChangeSet name
		including: (self otherChangeSets collect: [:each | each name]).

	dumper
		companionFiles: self companionFiles;
		readmeText: self readmeText;
		changesText: self changesText;
		fileOutAsZipNamed: 'SqueakDotNet.sar'
! !

!DotNet class methodsFor: 'releasing' stamp: 'jrp 12/7/2004 19:28'!
changesText

	^ '
Changes from R5 to R7

        It has been a while since we release a new edition of the bridge and we had a few
        unofficial R6 releases along the way.  We are jumping to R7 in this edition to 
        clean up some issues with there being several R6 editions.  This edition cleans up a few
        issues and introduces an direct plugin edition (for speed).  Namely:

	1. Both a direct plugin and sockets edition of the bridge are provided.

	2. Controlling COM automation components is possible in this edition.  There were issues with
        methods not functioning in prior versions when dealing with IDispatch components.

	3. A few other minor bugs where eradicated.

	4. A repackaging of the deployment to monticello format (MCZ) from the SAR approach in
        prior editions.

	NOTE:  This will be the last release that we maintain Squeak 3.5 and 3.6 compatibility.
     Future releases may or may not be functional with these versions of Squeak.

Changes from R4 to R5

	1. The bridge now provides a global instance of DotNet, so you do not have to create
	   one explicitly if you do not want to do so.  (You can if you''d like - for example,
	   if you''re controlling a client and a server at the same time.)

	   For example, instead of saying

	       | dotNet |
	       dotNet _ DotNet startNew.
	       dotNet Application run: dotNet Form new.

	   you could say

	       DotNet Application run: DotNet Form new.

	   One important note is that running the tests for global access,
	   which are contained in DotNetGlobalAccessTest, will exit and restart
	   the global instance a few times, causing any .NET object instances to
	   disappear.

	2. Handling of integers, floating-point numbers, and characters has been
	   improved.  The bridge now automatically translates Squeak integers to
	   .NET longs when necessary (and vice-versa), and also translates any
	   returned .NET integer (UInt32, Byte, etc.) into Squeak integers.

	   The bridge tries to pass floating-point numbers with double precision,
	   and then truncates them if necessary.  (This can, however, cause silent
	   loss of precision.)

	   Character objects are now translated automatically to and from .NET Chars.

	3. If the same .NET object is returned across the bridge twice, it will use the same
	   Squeak proxy.  This is also true for .NET types.

	4. Indexers with names other than Item (like StringBuilder''s Chars) now work
	   with #at: and #at:put:.  (Thanks to Rolf Gebauer for the idea and code to
	   make this work in the Ruby version.)

	5. DotNetObject>>#do now uses IEnumerable methods instead of looking for Count
	   or Length.  This allows more of the built-in .NET objects to work with the
	   Collection protocol.  (If you are relying on the older behavior, we would
	   be open to bringing it back or helping you install it in your image.)

	6. The bridge now supports objects that use "explicit interface implementation",
	   a .NET technique for implementing interfaces without exposing the names
	   of the implemented methods to most clients.  (Arrays'' IList implementations
	   are done in this way, and we have seen at least one list enumerator that
	   uses the technique.)

	7. The results of resolving types are now cached.  This should result in a
	   performance improvement for certain types of code, such as code that
	   creates objects in a loop.

	8. If a .NET object has a field and a property with the same name, differing only
	   by case, the bridge will access the property instead of the field.  This was likely
	   the case in the past, but is now defined to be so.

	9. Large strings are now received properly across the bridge.  Previous versions
	   had problems that would likely occur with strings over a few thousand
	   characters.

	10. The bridge now starts new threads in Single-Threaded Apartment mode.  This
	    should allow it to be used with Windows Forms drag-and-drop and with more
	    .NET-wrapped COM components.

	11. DotNet class>>#releaseNumber now returns the number of the bridge release
	    that is running.

	12. The bridge coordinates threads internally using a different mechanism.
	    Some of the internal communications protocol has also changed.

	    When you exit a bridge instance, if any process is blocking on a .NET result,
	    the bridge may signal an exception where it earlier would have hung.  If
	    your bridge exits when the image shuts down (for example, if you''re using
	    the global instance), this may manifest itself as a walkback at the next
	    startup.

Changes from R3 (first release) to R4

	1. Live bridge server processes automatically close when the image exits.

	2. The bridge now runs on Squeak 3.6 and 3.7 images as well as 3.5 images.

	3. There''s a more direct syntax for creating delegates explicitly.  (Event
	   handling and implicit delegate creation based on .NET parameter type
	   still work as they did before.)

	4. There have been a couple of internal changes related to the communications
	   protocol and to how event handler adding is processed - if you''re interested
	   in more information, please contact us.

	For more information on these changes, please see our swiki:

		http://www.saltypickle.com/SqueakDotNet/R4
'
! !

!DotNet class methodsFor: 'releasing' stamp: 'jrp 5/2/2004 23:38'!
companionFiles

	^ #('DotNetBridge.Server.exe'
		'DotNetBridge.Core.dll'
		'DotNetBridge.Core.so'), {DirectTransportPlugin moduleName, '.dll'}! !

!DotNet class methodsFor: 'info' stamp: 'jrp 12/7/2004 19:20'!
copyrightNotice

	^'Squeak/.Net Bridge (a.k.a. SqueakDotNet) - A bridge between Squeak and .Net
Copyright (c) 2004 Benjamin Schroeder and John R. Pierce

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

Contact Information

mailto:benschroeder@acm.org
mailto:john@pierce.name'! !

!DotNet class methodsFor: 'examples' stamp: 'bvs 8/25/2003 13:36'!
dialogExample

	"DotNet dialogExample"
	| dotNet form button |
	
	dotNet _ DotNet startNew.
	dotNet loadLibrary: 'System.Windows.Forms'.
	
	button _ dotNet Button new.
	button text: 'Hello'.
	button click add: [dotNet MessageBox show: 'Hello from Squeak'].
	
	form _ dotNet Form new.
	button dock: dotNet DockStyle fill.
	form controls add: button.
	
	form showDialog.

	dotNet exitDotNet.
! !

!DotNet class methodsFor: 'global access' stamp: 'bvs 10/16/2003 10:21'!
doesNotUnderstand: aMessage

	^ self instance
		perform: aMessage selector
		withArguments: aMessage arguments! !

!DotNet class methodsFor: 'private' stamp: 'bvs 9/22/2003 09:00'!
exitAllLiveInstances

	self allInstancesDo: [:each | each isAlive ifTrue: [each exitDotNet]]! !

!DotNet class methodsFor: 'releasing' stamp: 'bvs 9/16/2003 11:47'!
firstChangeSet

	^ self allChangeSets first! !

!DotNet class methodsFor: 'info' stamp: 'bvs 9/12/2003 09:07'!
furtherInformation

	^
'For further information, please visit our swikis at

	http://www.saltypickle.com/SqueakDotNet and
	http://www.saltypickle.com/RubyDotNet'
! !

!DotNet class methodsFor: 'global access' stamp: 'bvs 10/16/2003 10:23'!
instance

	(instance isNil or: [instance isAlive not]) ifTrue: [instance _ self startNew].

	^instance! !

!DotNet class methodsFor: 'releasing' stamp: 'bvs 9/16/2003 11:51'!
latestChangeSet

	^self allChangeSets last! !

!DotNet class methodsFor: 'as yet unclassified' stamp: 'jrp 7/27/2005 19:54'!
numericSqueakVersion

	| version digit index startsWithNumber versionClass |

	versionClass _ Smalltalk at: #SystemVersion ifAbsent: [nil].

	versionClass _ versionClass
		ifNil: [Smalltalk]
		ifNotNil: [versionClass current].

	version _ versionClass version.
	digit _ version detect: [:each | each isDigit].
	index _ version indexOf: digit.
	startsWithNumber _ version
		copyFrom: index
		to: version size.
	
	^startsWithNumber asNumber
	! !

!DotNet class methodsFor: 'releasing' stamp: 'bvs 9/16/2003 11:47'!
otherChangeSets

	^self allChangeSets allButFirst
! !

!DotNet class methodsFor: 'info' stamp: 'jrp 12/7/2004 19:27'!
otherSourceCode

	^
'The bridge comes (of course) with its Squeak source, but not the source of the .NET binaries that come with it. That source is available from

	http://www.saltypickle.com/RubyDotNet/downloads

in the latest RubyDotNet release zip.'! !

!DotNet class methodsFor: 'releasing' stamp: 'jrp 12/7/2004 19:22'!
readmeText

	^
'Squeak/.Net Bridge Copyright (C) 2004 Benjamin Schroeder and John R. Pierce
Terms and conditions can be found in DotNet class>>#copyrightNotice

This is release 7 of the Squeak/.NET Bridge, a program that lets you use .NET objects from your Squeak programs.

It is a port of a similar bridge that we wrote for Ruby, and still shares a backend with that bridge.  (The release numbering is based on the Ruby bridge, for consistency.  This is the fourth release of the Squeak version.)

Squeak/.NET Bridge is free software, licensed under the MIT license.

-- PREREQUISITES

The bridge runs under Microsoft .NET 1.1 and with Squeak 3.5, 3.6, 3.7, and 3.8 images.

-- COMPATIBILITY WITH OTHER VERSIONS OF .NET AND SQUEAK

We have tested the bridge on Windows with Microsoft''s .NET 1.1 implementation.  It might work on .NET 1.0, but you might need to rebuild the "Core" .NET binaries that the system uses.

We haven''t tried the bridge on any versions of Squeak earlier than 3.5.

-- AN EXAMPLE

Here is a basic example to show how code that uses the bridge looks. It uses the bridge''s global instance to create and manipulates an ArrayList, and uses Collection protocol to get a copy where all the Strings are reversed.

	| list reversed |
	
	list := DotNet ArrayList new.
	list add: ''Hello''.
	list add: ''World''.

	Transcript show: list count. "Prints <<2>>"
	
	reversed := list collect: [:each | each reversed].
	
	Transcript show: reversed asArray. "Prints #(''elloH'' ''dlroW'')"

We automatically convert Strings and SmallIntegers to .NET Strings and Int32s, and vice-versa. We do the same with nil and booleans. Doubles are passed to .NET with single-precision and back to Squeak with full double-precision when necessary.

We plan to add support for integers of different lengths and more complete support for floating-point numbers in the future.

-- FURTHER INFORMATION

For more information about the bridge and how to use it, please visit our swikis at

	www.saltypickle.com/SqueakDotNet and
	www.saltypickle.com/RubyDotNet

The SqueakDotNet swiki, like the bridge, is still mostly a port of the Ruby one, and is less complete.  The RubyDotNet swiki probably has useful information for people interested in the Squeak bridge.

If you would like to compile a version of the (C#) bridge binaries for yourself, please contact us for information on how to do so.

We hope you enjoy using the bridge!!  If you have any questions, comments, or ideas, please contact us.

Regards,

Ben Schroeder - benschroeder@acm.org
John Pierce - john@pierce.name

December 7, 2004
Columbus, OH
'! !

!DotNet class methodsFor: 'releasing' stamp: 'jrp 12/7/2004 19:20'!
releaseNumber

	^ 7! !

!DotNet class methodsFor: 'private' stamp: 'bvs 9/22/2003 09:00'!
shutDown: quitting

	quitting ifTrue: [self exitAllLiveInstances]! !

!DotNet class methodsFor: 'starting' stamp: 'bvs 12/4/2003 10:35'!
startNew

	^ self startNewDirect
! !

!DotNet class methodsFor: 'starting' stamp: 'bvs 12/4/2003 10:13'!
startNewDirect

	^ self new initializeWithTransport: DirectTransport startNew! !

!DotNet class methodsFor: 'starting' stamp: 'bvs 12/4/2003 10:28'!
startNewSockets

	^ self new initializeWithTransport: SocketTransport startNew
! !

!DotNet class methodsFor: 'as yet unclassified' stamp: 'bvs 9/12/2003 09:12'!
unimplementedTestsAndOtherNotes

	"testRubySyntaxExceptionDoesntMakeDotNetDie
	testLoadNonSystemTypes
	testLoadNonSystemTypesFromOtherFolder
	testPassDelegateToConstructor
	testRubySideOfDelegatesNotGarbageCollected
	PostOffice - testResultReturnsBeforeWait
	search for flag #todo
	(arrays are copied as ArrayLists ...)"

	"Moved some tests about exceptions to DotNetExceptionsTest - should we do the same in Ruby?"

	"Maybe missing namespaces should be nil in Squeak - that's what missing constants seem to be ..."! !

!DotNet methodsFor: 'default message handling' stamp: 'bvs 8/10/2003 23:03'!
defaultNamespace

	^ DotNetNamespace new initializeName: '' dotNet: self! !

!DotNet methodsFor: 'default message handling' stamp: 'bvs 8/10/2003 23:17'!
doesNotUnderstand: aMessage

	^ self defaultNamespace
		perform: aMessage selector
		withArguments: aMessage arguments
! !

!DotNet methodsFor: 'conversion from .net' stamp: 'bvs 11/5/2003 10:30'!
dotNetFromType: aString remoteId: anId


	aString = 'void' ifTrue: [^nil].
	(self integerTypes includes: aString) ifTrue: [^Integer readFrom: anId readStream].
	aString = 'System.String' ifTrue: [^anId].
	aString = 'System.RuntimeType' ifTrue:
		[^ self
			dotNetObjectOfClass: DotNetType
			withId: anId].
	aString = 'System.Boolean' ifTrue: [^anId = 'True'].
	aString = 'System.Char' ifTrue: [^anId asCharacter].
	(aString = 'System.Single' or: [aString = 'System.Double']) ifTrue: [^anId asNumber].
	aString = 'DotNetBridge.SocketsClientObject' ifTrue: [^rememberedObjects at: anId asInteger].

	^ self
		dotNetObjectOfClass: DotNetObject
		withId: anId
! !

!DotNet methodsFor: 'conversion from .net' stamp: 'bvs 12/3/2003 17:29'!
dotNetObjectOfClass: aSqueakClass withId: aString

	| result |
	dotNetSemaphore critical:
		[result _ dotNetObjects
			at: aString
			ifAbsent: [nil].
	
		result ifNil:
			[result _ dotNetObjects
				at: aString
				put: (aSqueakClass new
					initializeRemoteId: aString
					dotNet: self).
	
			dotNetWeakRegistry add: result].
	
		^ result]
! !

!DotNet methodsFor: 'commands' stamp: 'bvs 11/5/2003 09:59'!
dotNetSide

	self sendCommand: #('yourself').
	
	^ self receiveResult: self transportForCurrentProcess.

! !

!DotNet methodsFor: 'conversion to .net' stamp: 'bvs 10/21/2003 23:48'!
dotNetType: anObject

	(anObject isKindOf: String) ifTrue: [^'System.String'].
	(anObject isKindOf: Character) ifTrue: [^'System.Char'].
	(anObject isKindOf: Integer) ifTrue: [^'Integer'].
	(anObject isKindOf: Boolean) ifTrue: [^'System.Boolean'].
	(anObject isKindOf: Float) ifTrue: [^'System.Double'].
	anObject isNil ifTrue: [^'void'].
	(anObject isKindOf: DotNetObject) ifTrue: [^'System.Object'].
	(anObject isKindOf: DotNetException) ifTrue: [^'System.Object'].

	^'DotNetBridge.ClientObject'! !

!DotNet methodsFor: 'conversion to .net' stamp: 'bvs 2/12/2004 14:59'!
dotNetValue: anObject

	(anObject isKindOf: String) ifTrue: [^ anObject].
	(anObject isKindOf: Character) ifTrue: [^ anObject asString].
	(anObject isKindOf: DotNetObject) ifTrue: [^ anObject remoteId].
	(anObject isKindOf: DotNetException) ifTrue: [^ anObject remoteId].
	(anObject == true) ifTrue: [^ 'True'].
	(anObject == false) ifTrue: [^ 'False'].
	(anObject isKindOf: Number) ifTrue: [^ anObject asString].

	self remember: anObject.
	^ self objectId: anObject! !

!DotNet methodsFor: 'commands' stamp: 'bvs 12/12/2003 09:43'!
exitDotNet

	self isAlive ifFalse: [^self].

	self sendCommand: {'exit'}.

	mainTransport close.
	threadTransports valuesDo: [:each | each close].

	startedThreads do: [:each | each terminate].
! !

!DotNet methodsFor: 'commands' stamp: 'bvs 12/3/2003 17:44'!
finalizeDotNetObjectWithId: aString

	dotNetSemaphore critical:
		[(dotNetObjects includesKey: aString) ifTrue: [dotNetObjects removeKey: aString]]
! !

!DotNet methodsFor: 'results' stamp: 'bvs 10/23/2003 10:27'!
finishSendOnTransport: aTransport

	| kindOfReturn type remoteId exceptionId exceptionMessage |

	kindOfReturn _ aTransport receive.
	kindOfReturn = 'missing' ifTrue: [self signalException: MissingError new].

	kindOfReturn = 'rubyException' ifTrue:
		[exceptionId _ aTransport receive asInteger.
		self signalException: (rememberedObjects at: exceptionId)].

	type _ aTransport receive.
	remoteId _ aTransport receive.

	kindOfReturn = 'exception' ifTrue:
		[aTransport receive. "extra return type"
		aTransport receive. "the message's type (String)"
		exceptionMessage _ aTransport receive.

		self signalException: (DotNetException new
			initializeRemoteId: remoteId dotNet: self;
			messageText: exceptionMessage)].

	^ self
		dotNetFromType: type
		remoteId: remoteId
! !

!DotNet methodsFor: 'initialization' stamp: 'bvs 12/12/2003 09:17'!
initializeWithTransport: aTransport

	mainTransport _ aTransport.
	threadTransports _ Dictionary new.
	startedThreads _ OrderedCollection new.
	rememberedObjects _ Dictionary new.
	objectIds _ ObjectRegistry new initialize.
	dotNetObjects _ WeakValueDictionary new.
	dotNetWeakRegistry _ WeakRegistry new.
	dotNetSemaphore _ Semaphore forMutualExclusion.

	self
		receiveResultsForDotNetThread: mainTransport
		threadTransport: false.
! !

!DotNet methodsFor: 'conversion from .net' stamp: 'bvs 10/15/2003 21:44'!
integerTypes

	^ #('System.Int16' 'System.Int32' 'System.Int64' 'System.UInt16' 'System.UInt32' 'System.UInt64' 'System.Byte' 'System.SByte') ! !

!DotNet methodsFor: 'testing' stamp: 'bvs 11/5/2003 10:41'!
internalDotNetObjectCount

	^ dotNetObjects size
! !

!DotNet methodsFor: 'testing' stamp: 'bvs 12/12/2003 09:20'!
internalStartedThreadsDo: aBlock

	^ startedThreads do: aBlock
! !

!DotNet methodsFor: 'testing' stamp: 'bvs 10/7/2003 10:08'!
isAlive

	^mainTransport isAlive! !

!DotNet methodsFor: 'commands' stamp: 'bvs 8/12/2003 12:02'!
loadLibrary: assemblyName

	self System Reflection Assembly LoadWithPartialName: assemblyName! !

!DotNet methodsFor: 'commands' stamp: 'jrp 4/16/2004 23:45'!
loadLibraryFromFile: fileName

	self System Reflection Assembly loadFrom: fileName! !

!DotNet methodsFor: 'conversion to .net' stamp: 'bvs 8/29/2003 09:35'!
objectId: aSqueakObject

	^objectIds objectId: aSqueakObject
! !

!DotNet methodsFor: 'results' stamp: 'bvs 12/3/2003 15:17'!
receiveResult: aTransport

	| command |

	[true] whileTrue:
		[aTransport wait.

		command _ aTransport receive.
		command = 'startAnother' ifTrue: [self startAnotherTransport].
		command = 'finish' ifTrue: [^self finishSendOnTransport: aTransport].
		command = 'method' ifTrue: [self runCallbackOnTransport: aTransport]].
	! !

!DotNet methodsFor: 'results' stamp: 'jrp 5/22/2004 10:16'!
receiveResultsForDotNetThread: aTransport threadTransport: aBoolean

	| newProcess |
	newProcess _ [aBoolean ifTrue:
		[threadTransports
			at: Processor activeProcess
			ifAbsentPut: aTransport].

		[[true] whileTrue: [self receiveResult: aTransport]]
			on: Exception
			do: [:exception | ]] newProcess.
		
	(newProcess respondsTo: #name:) ifTrue: [newProcess name: 'dotnet'].

	startedThreads add: newProcess.

	newProcess resume.
! !

!DotNet methodsFor: 'conversion to .net' stamp: 'bvs 8/29/2003 09:00'!
remember: anObject

	rememberedObjects
		at: (self objectId: anObject)
		put: anObject! !

!DotNet methodsFor: 'commands' stamp: 'bvs 10/14/2003 22:37'!
resolveType: typeName

	| result |

	self sendCommand:
		{'resolveType'.
		typeName}.

	result _ self receiveResult: self transportForCurrentProcess.
	^result isNil
		ifTrue: [DotNetNamespace new initializeName: typeName dotNet: self]
		ifFalse: [result]
! !

!DotNet methodsFor: 'results' stamp: 'bvs 10/14/2003 22:59'!
runCallbackOnTransport: aTransport

	| callbackId messageName argCount argType argId arguments message callback result |

	aTransport receive. "call or set"
	callbackId _ aTransport receive.
	messageName _ aTransport receive.

	argCount _ aTransport receive asInteger.
	arguments _ Array new: argCount.
	1
		to: argCount
		do:
			[:i |
			aTransport receive. "extra return type"
			argType _ aTransport receive.
			argId _ aTransport receive.

			arguments
				at: i
				put: (self dotNetFromType: argType remoteId: argId)].

	message _ MessageFromDotNet new
		messageName: messageName
		args: arguments.

	callback _ rememberedObjects at: callbackId asInteger.
	[result _ callback
		perform: message selector
		withArguments: message args.
	
	self sendCommand:
		{'finish'.
		self dotNetType: result.
		self dotNetValue: result}]
		on: Exception
		do:
			[:exception |
			self remember: exception.

			self sendCommand:
				{'exception'.
				self objectId: exception.
				exception class name.
				self dotNetType: exception messageText.
				self dotNetValue: exception messageText}]
! !

!DotNet methodsFor: 'commands' stamp: 'bvs 12/3/2003 15:18'!
sendCommand: commandLines

	commandLines do: [:each | self transportForCurrentProcess send: each].
	self transportForCurrentProcess signal.! !

!DotNet methodsFor: 'commands' stamp: 'bvs 2/12/2004 14:47'!
sendMessageFrom: dotNetObject selector: aSymbol arguments: aList

	| messageName packedArguments commandLines |

	messageName _ self upToFirstColon: aSymbol asString.
	messageName last = $: ifTrue: [messageName _ messageName allButLast].

	packedArguments _ {dotNetObject}, aList.

	commandLines _ OrderedCollection new.
	commandLines
		add: 'method';
		add: messageName;
		add: packedArguments size.

	packedArguments do:
		[:each |
		commandLines
			add: (self dotNetType: each);
			add: (self dotNetValue: each)].

	self sendCommand: commandLines.

	^self receiveResult: self transportForCurrentProcess
! !

!DotNet methodsFor: 'results' stamp: 'bvs 10/23/2003 10:27'!
signalException: anException

	DotNet numericSqueakVersion < 3.6 ifTrue: [anException initialContext: thisContext sender].

	anException signal.
! !

!DotNet methodsFor: 'results' stamp: 'bvs 11/5/2003 09:41'!
startAnotherTransport

	| newTransport |
	newTransport _ mainTransport serverRequestedStartAnother.

	self
		receiveResultsForDotNetThread: newTransport
		threadTransport: true.
! !

!DotNet methodsFor: 'commands' stamp: 'bvs 10/14/2003 20:45'!
transportForCurrentProcess

	^ threadTransports
		at: Processor activeProcess
		ifAbsentPut: [mainTransport startAnother]
! !

!DotNet methodsFor: 'commands' stamp: 'bvs 8/11/2003 22:09'!
upToFirstColon: aString

	| firstColon |
	firstColon _ aString indexOf: $:.
	
	^firstColon = 0
		ifTrue: [aString]
		ifFalse: [aString copyFrom: 1 to: firstColon]! !

Object subclass: #DotNetBenchmarks
	instanceVariableNames: 'dotNet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Tests Support'!

!DotNetBenchmarks class methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:21'!
new

	^ super new initialize! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:22'!
benchmarkIndexing

	| list |
	list _ dotNet ArrayList new.
	list add: 'a'.
	list add: 'b'.
	list add: 'c'.

	^ Time millisecondsToRun: [1000 timesRepeat: [list at: 1]].! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:24'!
benchmarkNewListCount

	^ Time millisecondsToRun: [1000 timesRepeat: [dotNet ArrayList new count]]! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:24'!
benchmarkSingleMethod

	| list |
	list _ dotNet ArrayList new.
	list add: 'a'.
	list add: 'b'.
	list add: 'c'.

	^ Time millisecondsToRun: [1000 timesRepeat: [list count]].! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:24'!
benchmarkTypeResolution

	^ Time millisecondsToRun: [1000 timesRepeat: [dotNet ArrayList]]! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:21'!
initialize

	dotNet _ DotNet! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:28'!
runBenchmarks

	| output |
	output _ '' writeStream.

	self selectorsForBenchmarks do:
		[:each | | time |
		time _ self perform: each.
		output
			nextPutAll: each;
			nextPutAll: ': ';
			nextPutAll: time asString;
			cr].

	^ output contents! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
runBenchmarksWithDirect

	dotNet _ DotNet startNewDirect.
	^ self runBenchmarks
! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 17:41'!
runBenchmarksWithSockets

	dotNet _ DotNet.
	^ self runBenchmarks
! !

!DotNetBenchmarks methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 09:28'!
selectorsForBenchmarks

	^ #(benchmarkIndexing
		benchmarkNewListCount
		benchmarkSingleMethod
		benchmarkTypeResolution)! !

Object subclass: #DotNetBridgeExternalFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Externals'!

!DotNetBridgeExternalFile class methodsFor: 'files' stamp: 'jrp 12/7/2004 19:04'!
archive

^ 'H4sIAAAAAAAAAOTdY6zwThgo+GPbtm3btm3btm3b5z22bdu2bb1n/7vJZu+9i4/75c2kbWY6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' reconstituteObject! !

!DotNetBridgeExternalFile class methodsFor: 'files' stamp: 'jrp 5/3/2004 23:04'!
attemptToReplaceFile: file during: aBlock
 
	| noMoreAttempts requiredRename |
	noMoreAttempts _ false.
	requiredRename _ false.
	
	aBlock
		on: CannotDeleteFileException
		do: 
			[:exception |
			noMoreAttempts 
				ifTrue: [exception signal]
				ifFalse: 
					[FileDirectory default deleteFileNamed: (file, '.trash').
					FileDirectory default rename: file toBe: (file, '.trash').
					noMoreAttempts _ true.
					requiredRename _ true.
					exception retry]].
			
	^ requiredRename! !

!DotNetBridgeExternalFile class methodsFor: 'accessing' stamp: 'jrp 5/2/2004 19:45'!
buildDirectory

	| buildDir |
	buildDir _ FileDirectory default directoryNamed: 'DotNetBridge Plugin Build'.
	buildDir assureExistence.
	
	^ buildDir! !

!DotNetBridgeExternalFile class methodsFor: 'encoding' stamp: 'jrp 7/25/2004 21:27'!
copyZip: zip toSelector: aSymbol

	| stream |
	stream _ RWBinaryOrTextStream on: (ByteArray new: 5000).
	zip writeTo: stream.
	self store: stream asSelector: aSymbol! !

!DotNetBridgeExternalFile class methodsFor: 'decoding' stamp: 'jrp 12/7/2004 19:06'!
deployAll
	
	| zip rebootRequired |
	zip _ ZipArchive new readFrom: self archive.
	rebootRequired _ false.
	
	zip members do: 
		[:each | | renamedFile |
		renamedFile _ self 
			attemptToReplaceFile: each fileName
			during: [zip extractMember: each].
			
		renamedFile ifTrue: [rebootRequired _ true]].
	
	rebootRequired ifTrue: [self inform: self needsRebootMessage]! !

!DotNetBridgeExternalFile class methodsFor: 'encoding' stamp: 'jrp 5/2/2004 23:36'!
encodeAll

	| zip |
	zip _ ZipArchive new.
	
	DotNet companionFiles do: [:each | zip addFile: each].

	self copyZip: zip toSelector: #archive! !

!DotNetBridgeExternalFile class methodsFor: 'class initialization' stamp: 'bvs 4/16/2004 10:55'!
initialize

	"Called when a Monticello version of this package is loaded"

	self deployAll.
! !

!DotNetBridgeExternalFile class methodsFor: 'accessing' stamp: 'jrp 5/2/2004 20:22'!
needsRebootMessage

	^ 'You must save and restart Squeak to complete the installation of the new version of DotNet!!'! !

DotNetBridgeExternalFile subclass: #DotNetBridgePluginFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Externals'!

!DotNetBridgePluginFile class methodsFor: 'as yet unclassified' stamp: 'jrp 5/3/2004 00:00'!
buildNewVersion

	| directory compileBatch buildOutputStream buildOutput pluginDll rebootRequired |
	
	directory _ self buildDirectory.
	DotNetBridgePluginSupportingSource deploy.
	DotNetBridgeSqueakHeaders deploy.
	DirectTransportPlugin writeCFilesToDirectory: directory.
	self copySoFile.
	
	directory deleteFileNamed: 'buildOutput.txt'.
	directory deleteFileNamed: 'done.txt'.

	compileBatch _ directory forceNewFileNamed: 'compile.bat'.
	compileBatch
		nextPutAll: 'call "C:\Program Files\Microsoft Visual Studio .NET 2003\Common7\Tools\vsvars32.bat"';
		nextPutAll: String crlf;
		nextPutAll: 'cl /LD /clr /DTRACE /EHsc /ISqueakHeaders *.c *.cpp > buildOutput.txt';
		nextPutAll: String crlf;
		nextPutAll: 'echo done > done.txt'.
	compileBatch close.

	Win32Shell new
		shellExecute: nil
		lpOperation: 'open'
		lpFile: 'cmd'
		lpParameters: '/c compile.bat'
		lpDirectory: self buildDirectory localName
		nShowCmd: 0.

	[directory isAFileNamed: 'done.txt'] whileFalse: [(Delay forMilliseconds: 100) wait].

	buildOutputStream _ directory oldFileNamed: 'buildOutput.txt'.
	buildOutput _ buildOutputStream contents.
	buildOutputStream close.

	(buildOutput includesSubString: ' error ') ifTrue:
		[self notify: 'Build Failed', String cr, String cr, buildOutput].

	Smalltalk unloadModule: DirectTransportPlugin moduleName.
	pluginDll _ DirectTransportPlugin moduleName, '.dll'.
	
	rebootRequired _ (self
		attemptToReplaceFile: pluginDll
		during:
			[self
				copyFileNamed: self buildDirectory localName, '\', pluginDll
				toFileNamed: pluginDll]).
			
	rebootRequired ifTrue: [self inform: 'You must save and restart Squeak to load the new DirectTransportPlugin that was just built!!']! !

!DotNetBridgePluginFile class methodsFor: 'as yet unclassified' stamp: 'jrp 12/7/2004 15:18'!
copyFileNamed: sourceString toFileNamed: targetString

	| source target |
	source _ (FileStream readOnlyFileNamed: sourceString) binary.
	target _ (FileStream forceNewFileNamed: targetString) binary.
	FileDirectory root
		copyFile: source
		toFile: target.
	source close.
	target close.! !

!DotNetBridgePluginFile class methodsFor: 'as yet unclassified' stamp: 'jrp 5/2/2004 19:54'!
copySoFile

	self
		copyFileNamed: 'DotNetBridge.Core.so'
		toFileNamed: self buildDirectory localName, '\DotNetBridge.Core.so'.
! !

DotNetBridgeExternalFile subclass: #DotNetBridgePluginSupportingSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Externals'!

!DotNetBridgePluginSupportingSource class methodsFor: 'as yet unclassified' stamp: 'jrp 5/2/2004 19:41'!
deploy

	| headerStream cppStream |
	
	headerStream _ CrLfFileStream forceNewFileNamed: (self buildDirectory fullNameFor: 'DirectTransportPlugin.h').
	headerStream nextPutAll: self headerFile.
	headerStream close.

	cppStream _ CrLfFileStream forceNewFileNamed: (self buildDirectory fullNameFor: 'DirectTransportPluginNative.cpp').
	cppStream nextPutAll: self dotNetLinkageCppFile.
	cppStream close.
! !

!DotNetBridgePluginSupportingSource class methodsFor: 'as yet unclassified' stamp: 'bvs 4/16/2004 17:01'!
dotNetLinkageCppFile

	^ '#using <mscorlib.dll>
#using <System.dll>
#using <DotNetBridge.Core.so>

#include <new.h>
#include <string.h>
#include <time.h>
#include <vcclr.h>

#include <algorithm>
#include <vector>

#include "sqVirtualMachine.h"

using namespace System;
using namespace System::Collections;
using namespace System::Runtime::InteropServices;

using namespace DotNetBridge;

using namespace std;

typedef struct DirectTransportWrapper DirectTransportWrapper;

vector<int> activeWrappers;

struct DirectTransportWrapper
{
    gcroot<DirectTransport*> directTransport;

    int Handle() {
        int* mem_address = (int*)this;

        return (int)(*mem_address);
    }

    bool NotValid() {
        vector<int>::iterator result = find(activeWrappers.begin(), activeWrappers.end(), Handle());
        return result == activeWrappers.end();
    }

    void RegisterAsActive() {
        activeWrappers.push_back(Handle());
    }
};

#define VERIFY_VALID_WRAPPER(wrapper) if (wrapper->NotValid())  {interpreterProxy->primitiveFail(); return;}

#define VERIFY_VALID_WRAPPER_AND_RETURN(wrapper, returnValue) if (wrapper->NotValid())  {interpreterProxy->primitiveFail(); return returnValue;}

extern "C" {
    extern struct VirtualMachine* interpreterProxy;

    void SetupSession() {
    }

    int SizeOfDirectTransportWrapper() {
        return sizeof(DirectTransportWrapper);
    }
    
    void InitializeDirectTransportWrapper(DirectTransportWrapper* wrapper) {
        new (wrapper) DirectTransportWrapper;
        wrapper->RegisterAsActive();

        wrapper->directTransport = DirectTransport::CreateWithNewBridge();
    }
    
    void InitializeDirectTransportWrapperBasedOnAnother(DirectTransportWrapper* wrapper, DirectTransportWrapper* oldWrapper) {
        VERIFY_VALID_WRAPPER(oldWrapper);
        new (wrapper) DirectTransportWrapper;
        wrapper->RegisterAsActive();
        
        wrapper->directTransport = oldWrapper->directTransport->CreateAnother();
    }
    
    void InitializeServerRequestedDirectTransportWrapperBasedOnAnother(DirectTransportWrapper* wrapper, DirectTransportWrapper* oldWrapper) {
        VERIFY_VALID_WRAPPER(oldWrapper);
        new (wrapper) DirectTransportWrapper;
        wrapper->RegisterAsActive();
        
        wrapper->directTransport = oldWrapper->directTransport->ClientReceiveNewTransport();
    }
    
    int GetDirectTransportControlPort(DirectTransportWrapper* wrapper) {
        VERIFY_VALID_WRAPPER_AND_RETURN(wrapper, 0);
        return wrapper->directTransport->ControlPort;
    }
    
    void FinishDirectTransportInitialization(DirectTransportWrapper* wrapper) {
        VERIFY_VALID_WRAPPER(wrapper);
        wrapper->directTransport->WaitForInitialization();
    }
    
    void DirectTransportStartReceiving(DirectTransportWrapper* wrapper) {
        VERIFY_VALID_WRAPPER(wrapper);
        wrapper->directTransport->StartReceivingOnNewThread();
    }
    
    void DirectTransportSend(DirectTransportWrapper* wrapper, char* stringData, int stringDataSize) {
        char* buffer;

        VERIFY_VALID_WRAPPER(wrapper);

        buffer = new char[stringDataSize + 1];
        strncpy(buffer, stringData, stringDataSize);
        buffer[stringDataSize] = 0;
        
        wrapper->directTransport->ClientSend(new String(buffer));
        
        delete buffer;
    }
    
    int DirectTransportNextReceiveSize(DirectTransportWrapper* wrapper) {
        VERIFY_VALID_WRAPPER_AND_RETURN(wrapper, 0);

        return wrapper->directTransport->ClientNextReceiveSize();
    }
    
    void DirectTransportReceive(DirectTransportWrapper* wrapper, char* buffer) {
        VERIFY_VALID_WRAPPER(wrapper);

        String* dotNetString = wrapper->directTransport->ClientReceive();
        
        IntPtr ptr = Marshal::StringToHGlobalAnsi(dotNetString);
        const char* ansiChars = static_cast<const char*>(ptr.ToPointer());
        strncpy(buffer, ansiChars, dotNetString->Length);
        Marshal::FreeHGlobal(ptr);
    }
}
'! !

!DotNetBridgePluginSupportingSource class methodsFor: 'as yet unclassified' stamp: 'bvs 4/16/2004 15:06'!
headerFile

	^ '#ifndef _DIRECTTRANSPORTPLUGIN_H
#define _DIRECTTRANSPORTPLUGIN_H

typedef struct DirectTransportWrapper DirectTransportWrapper;

void SetupSession();
int SizeOfDirectTransportWrapper();
void InitializeDirectTransportWrapper(DirectTransportWrapper* wrapper);
void InitializeDirectTransportWrapperBasedOnAnother(DirectTransportWrapper* wrapper, DirectTransportWrapper* oldWrapper);
void InitializeServerRequestedDirectTransportWrapperBasedOnAnother(DirectTransportWrapper* wrapper, DirectTransportWrapper* oldWrapper);
int GetDirectTransportControlPort(DirectTransportWrapper* wrapper);
void FinishDirectTransportInitialization(DirectTransportWrapper* wrapper);
void DirectTransportStartReceiving(DirectTransportWrapper* wrapper);
void DirectTransportSend(DirectTransportWrapper* wrapper, char* stringData, int stringDataSize);
int DirectTransportNextReceiveSize(DirectTransportWrapper* wrapper);
void DirectTransportReceive(DirectTransportWrapper* wrapper, char* buffer);

#endif
'! !

DotNetBridgeExternalFile subclass: #DotNetBridgeSqueakHeaders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Externals'!

!DotNetBridgeSqueakHeaders class methodsFor: 'as yet unclassified' stamp: 'jrp 5/3/2004 07:55'!
deploy

	| zip |
	zip _ ZipArchive new readFrom: (self headersArchive reconstituteStream).

	zip members do:
		[:each |
		zip
			extractMemberWithoutPath: each
			inDirectory: self headersDirectory]! !

!DotNetBridgeSqueakHeaders class methodsFor: 'as yet unclassified' stamp: 'jrp 5/2/2004 20:10'!
encode

	| headerNames zip |

	headerNames _ self headersDirectory fileNames select: [:each | each endsWith: '.h'].

	zip _ ZipArchive new.
	headerNames do: [:each | zip addFile: (self headersDirectory fullNameFor: each)].
	
	self copyZip: zip toSelector: #headersArchive! !

!DotNetBridgeSqueakHeaders class methodsFor: 'as yet unclassified' stamp: 'jrp 5/2/2004 20:11'!
headersArchive

^ 'H4sIAAAAAAAAAM38Y5BtzZYGCpdtu2qXbRu7bNu2bdu2bVu7bJu7bJv3PV93x9tnd3z3xzkd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'! !

!DotNetBridgeSqueakHeaders class methodsFor: 'as yet unclassified' stamp: 'jrp 5/2/2004 19:40'!
headersDirectory

	^ self buildDirectory directoryNamed: 'SqueakHeaders'! !

Object subclass: #DotNetNamespace
	instanceVariableNames: 'name dotNet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!DotNetNamespace commentStamp: 'bvs 9/11/2003 14:06' prior: 0!
A .NET namespace.  Resolves messages to answer either types or sub-namespaces.!

!DotNetNamespace methodsFor: 'as yet unclassified' stamp: 'bvs 9/10/2003 13:48'!
doesNotUnderstand: aMessage

	^ [dotNet resolveType: (self memberSymbol: aMessage selector)]
		on: MissingError
		do: [^super doesNotUnderstand: aMessage]
! !

!DotNetNamespace methodsFor: 'as yet unclassified' stamp: 'bvs 8/10/2003 23:03'!
initialize: aDotNet

	! !

!DotNetNamespace methodsFor: 'as yet unclassified' stamp: 'bvs 8/10/2003 23:03'!
initializeName: aString dotNet: aDotNet

	name _ aString.
	dotNet _ aDotNet.	! !

!DotNetNamespace methodsFor: 'as yet unclassified' stamp: 'bvs 8/18/2003 15:57'!
memberSymbol: singleNameSymbol

	name = '' ifTrue: [^singleNameSymbol].

	^ (name, '.', singleNameSymbol asString) asSymbol! !

!DotNetNamespace methodsFor: 'as yet unclassified' stamp: 'bvs 9/10/2003 13:47'!
name

	^name
! !

Object subclass: #DotNetObjectExecutor
	instanceVariableNames: 'dotNet remoteId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!DotNetObjectExecutor methodsFor: 'accessing' stamp: 'bvs 11/5/2003 10:43'!
dotNet: aDotNet

	dotNet _ aDotNet
! !

!DotNetObjectExecutor methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 12:48'!
finalize

	dotNet finalizeDotNetObjectWithId: remoteId
! !

!DotNetObjectExecutor methodsFor: 'accessing' stamp: 'bvs 11/5/2003 10:43'!
remoteId: aString

	remoteId _ aString
! !

Object subclass: #ICollectionImplementation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Tests Support'!

!ICollectionImplementation methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:26'!
CopyTo: anArray with: startIndex

	anArray
		at: 0
		put: 'hello'.

	anArray
		at: 1
		put: 'world'.! !

!ICollectionImplementation methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:25'!
Count

	^2! !

!ICollectionImplementation methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:25'!
SyncRoot

	^self! !

Object subclass: #MessageFromDotNet
	instanceVariableNames: 'selector args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!MessageFromDotNet methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:30'!
args

	^args! !

!MessageFromDotNet methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:39'!
initializeAsBlockValueMessage: argsList

	selector _ #valueWithPossibleArgs:.
	args _ Array with: argsList.! !

!MessageFromDotNet methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:38'!
messageName: aString args: aList

	| selectorString |
	aString = '*' ifTrue: [^self initializeAsBlockValueMessage: aList].

	selectorString _ aString.
	aList isEmpty ifFalse: [selectorString _ selectorString, ':'].

	2
		to: aList size
		do: [:i | selectorString _ selectorString, 'with:'].
	
	selector _ selectorString asSymbol.
	args _ aList.! !

!MessageFromDotNet methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:30'!
selector

	^selector! !

Object subclass: #ObjectRegistry
	instanceVariableNames: 'objectIds nextId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!ObjectRegistry methodsFor: 'as yet unclassified' stamp: 'bvs 8/29/2003 09:30'!
initialize

	objectIds _ Dictionary new.
	nextId _ 1.! !

!ObjectRegistry methodsFor: 'as yet unclassified' stamp: 'bvs 8/29/2003 09:30'!
nextId

	| id |
	id _ nextId.
	nextId _ nextId + 1.
	^id! !

!ObjectRegistry methodsFor: 'as yet unclassified' stamp: 'bvs 8/29/2003 09:30'!
objectId: anObject

	^objectIds
		at: anObject
		ifAbsentPut: [self nextId].! !

!ObjectRegistry methodsFor: 'as yet unclassified' stamp: 'bvs 8/29/2003 09:34'!
registerObject: anObject withId: idObject

	objectIds
		at: anObject
		put: idObject! !

Object subclass: #SocketTransport
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!SocketTransport class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:29'!
startDotNetServerOnPort: aNumber

	Win32Shell new
		shellExecute: nil
		lpOperation: 'open'
		lpFile: 'DotNetBridge.Server.exe'
		lpParameters: aNumber asString
		lpDirectory: nil
		nShowCmd: 1.
! !

!SocketTransport class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:28'!
startNew

	| server port |

	Socket initializeNetwork.
	server _ DotNetSocket newTCP.
	server listenOn: (Socket wildcardPort).

	port _ server primSocketLocalPort: server socketHandle.
	self startDotNetServerOnPort: port.

	server waitForConnectionUntil: (Socket deadlineSecs: 60).

	^ self new initialize: server
! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 10/7/2003 09:21'!
close

	socket close! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 10/7/2003 09:18'!
initialize: aSocket

	socket _ aSocket! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 10/7/2003 09:21'!
isAlive

	^ socket isConnected! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 10/14/2003 22:58'!
receive

	| lineLength |
	lineLength _ socket getResponse asInteger.
	^socket readBytes: lineLength.
! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 10/14/2003 22:57'!
send: anObject

	| string |
	string _ anObject asString.

	socket sendData: string size asString, String crlf.
	socket sendData: string.
! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 10/14/2003 22:55'!
serverRequestedStartAnother

	| port localhostAddr newSocket |
	port _ self receive asInteger.

	localhostAddr _ NetNameResolver
		addressForName: 'localhost'
		timeout: 10.

	newSocket _ DotNetSocket new
		connectTo: localhostAddr
		port: port.
	newSocket waitForConnectionUntil: (Socket deadlineSecs: 60).

	^SocketTransport new initialize: newSocket
! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:15'!
signal

	! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 10/14/2003 20:46'!
startAnother

	| server port |

	Socket initializeNetwork.
	server _ DotNetSocket newTCP.
	server listenOn: (Socket wildcardPort).

	port _ server primSocketLocalPort: server socketHandle.

	self send: 'startAnother'.
	self send: port.

	server waitForConnectionUntil: (Socket deadlineSecs: 60).

	^ SocketTransport new initialize: server
! !

!SocketTransport methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:15'!
wait

	! !

Collection subclass: #DotNetObject
	instanceVariableNames: 'remoteId dotNet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!DotNetObject commentStamp: 'bvs 9/11/2003 14:06' prior: 0!
A proxy for a .NET object.  Uses #doesNotUnderstand: to forward messages to the object on the .NET side.
!

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:01'!
add: anObject

	^self Add: anObject "to call .NET method instead of Collection method"! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 10/30/2003 09:12'!
at: index

	^self
		sendToDotNet: '[]' asSymbol
		arguments: {index}.
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 10/30/2003 09:12'!
at: index put: anObject

	self
		perform: '[]' asSymbol
		withArguments: {index. anObject}.

	^self at: index
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 10/8/2003 09:41'!
do: aBlock

	| enumerator |
	enumerator _ self getEnumerator.
	[enumerator moveNext] whileTrue: [aBlock value: enumerator current].
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 10/30/2003 09:11'!
doesNotUnderstand: aMessage

	^[self
		sendToDotNet: aMessage selector
		arguments: aMessage arguments]
		on: MissingError
		do: [^super doesNotUnderstand: aMessage]
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 09:29'!
dotNet

	^dotNet! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 10:43'!
executor

	^ DotNetObjectExecutor new
		dotNet: dotNet;
		remoteId: remoteId
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 12:49'!
hash

	"To avoid calling Collection's hash"

	^ self identityHash
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 10:55'!
initializeRemoteId: anId dotNet: aDotNet

	remoteId _ anId.
	dotNet _ aDotNet.! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 10:17'!
printOn: aStream

	aStream nextPutAll: self toString! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 10:55'!
remoteId

	^remoteId! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 10/24/2003 13:07'!
remove: anObject

	^self Remove: anObject "to call .NET method instead of Collection method"! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'bvs 10/30/2003 09:11'!
sendToDotNet: aSelector arguments: aList

	^dotNet
		sendMessageFrom: self
		selector: aSelector
		arguments: aList
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'jrp 7/27/2005 19:36'!
species

	| type |
	type _ self GetType.

	^type isArray
		ifTrue: [dotNet ArrayList]
		ifFalse: 
			[[type new. type] 
				on: MessageNotUnderstood 
				do: [:ex | OrderedCollection]]
! !

!DotNetObject methodsFor: 'as yet unclassified' stamp: 'jrp 8/3/2004 14:29'!
usingSelfDo: aOneArgBlock

	[aOneArgBlock value: self] ensure: [self dispose]! !

DotNetObject subclass: #DotNetType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Kernel'!

!DotNetType commentStamp: 'bvs 9/11/2003 14:07' prior: 0!
A proxy for a .NET type.  Answers both .NET static messages (like messages sent to classes) and messages from .NET's Type class.
!

!DotNetType methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:30'!
Array

	^dotNet perform: (self fullName, '[]') asSymbol! !

InterpreterPlugin subclass: #DirectTransportPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin'!

!DirectTransportPlugin class methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 13:25'!
hasHeaderFile

	^ true! !

!DirectTransportPlugin class methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 13:25'!
moduleName

	^ 'DirectTransportPlugin'
! !

!DirectTransportPlugin class methodsFor: 'as yet unclassified' stamp: 'bvs 4/16/2004 11:07'!
writeCFilesToDirectory: aFileDirectory

	self 
		translateInDirectory: aFileDirectory
		doInlining: true.
! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 4/16/2004 15:06'!
initialiseModule

	self export: true.

	self cCode: 'SetupSession()'.

	^ true! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 14:21'!
primControlPort

	| receiver wrapperOop wrapper |
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self export: true.
	self inline: false.

	receiver _ interpreterProxy stackObjectValue: 0.
	wrapperOop _ interpreterProxy
		fetchPointer: 0
		ofObject: receiver.
	wrapper _ self wrapperValueOf: wrapperOop.
	
	interpreterProxy pop: 1.
	interpreterProxy pushInteger: (self cCode: 'GetDirectTransportControlPort(wrapper)').
! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 14:21'!
primCreateDirectTransport

	| receiver wrapperOop wrapper |
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self export: true.
	self inline: false.

	receiver _ interpreterProxy stackObjectValue: 0.
	
	wrapperOop _ interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: (self cCode: 'SizeOfDirectTransportWrapper()').
	wrapper _ self wrapperValueOf: wrapperOop.
	self cCode: 'InitializeDirectTransportWrapper(wrapper)'.

	interpreterProxy
		storePointer: 0
		ofObject: receiver
		withValue: wrapperOop.
	! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 14:59'!
primCreateDirectTransportBasedOn ": aDotNetSide"

	| receiver oldWrapperOop oldWrapper wrapperOop wrapper |
	self var: 'oldWrapper' type: 'DirectTransportWrapper*'.
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self export: true.
	self inline: false.

	oldWrapperOop _ interpreterProxy stackObjectValue: 0.
	oldWrapper _ self wrapperValueOf: oldWrapperOop.

	receiver _ interpreterProxy stackObjectValue: 1.
	
	wrapperOop _ interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: (self cCode: 'SizeOfDirectTransportWrapper()').
	wrapper _ self wrapperValueOf: wrapperOop.
	self cCode: 'InitializeDirectTransportWrapperBasedOnAnother(wrapper, oldWrapper)'.

	interpreterProxy
		storePointer: 0
		ofObject: receiver
		withValue: wrapperOop.
	
	interpreterProxy pop: 1.
! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:12'!
primCreateServerRequestedDirectTransportBasedOn ": aDotNetSide"

	| receiver oldWrapperOop oldWrapper wrapperOop wrapper |
	self var: 'oldWrapper' type: 'DirectTransportWrapper*'.
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self export: true.
	self inline: false.

	oldWrapperOop _ interpreterProxy stackObjectValue: 0.
	oldWrapper _ self wrapperValueOf: oldWrapperOop.

	receiver _ interpreterProxy stackObjectValue: 1.
	
	wrapperOop _ interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: (self cCode: 'SizeOfDirectTransportWrapper()').
	wrapper _ self wrapperValueOf: wrapperOop.
	self cCode: 'InitializeServerRequestedDirectTransportWrapperBasedOnAnother(wrapper, oldWrapper)'.

	interpreterProxy
		storePointer: 0
		ofObject: receiver
		withValue: wrapperOop.
	
	interpreterProxy pop: 1.
! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:46'!
primDirectTransportReceive

	| receiver wrapperOop wrapper newStringPointer newString |
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self var: 'newString' type: 'char*'.
	self export: true.
	self inline: false.

	receiver _ interpreterProxy stackObjectValue: 0.
	wrapperOop _ interpreterProxy
		fetchPointer: 0
		ofObject: receiver.
	wrapper _ self wrapperValueOf: wrapperOop.

	newStringPointer _ interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: (self cCode: 'DirectTransportNextReceiveSize(wrapper)').
	newString _ interpreterProxy firstIndexableField: newStringPointer.

	self cCode: 'DirectTransportReceive(wrapper, newString)'.

	interpreterProxy pop: 1.
	interpreterProxy push: newStringPointer.
! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 17:14'!
primDirectTransportSend ": aString size: aNumber"

	| aStringOop aString receiver wrapperOop wrapper aNumber |
	self var: 'aString' type: 'char*'.
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self export: true.
	self inline: false.

	aNumber _ interpreterProxy stackIntegerValue: 0.

	aStringOop _ interpreterProxy stackObjectValue: 1.
	aString _ interpreterProxy firstIndexableField: aStringOop.
	
	receiver _ interpreterProxy stackObjectValue: 2.
	wrapperOop _ interpreterProxy
		fetchPointer: 0
		ofObject: receiver.
	wrapper _ self wrapperValueOf: wrapperOop.

	interpreterProxy pop: 2.
	self cCode: 'DirectTransportSend(wrapper, aString, aNumber)'.
! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:06'!
primFinishInitialization

	| receiver wrapperOop wrapper |
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self export: true.
	self inline: false.

	receiver _ interpreterProxy stackObjectValue: 0.
	wrapperOop _ interpreterProxy
		fetchPointer: 0
		ofObject: receiver.
	wrapper _ self wrapperValueOf: wrapperOop.

	self cCode: 'FinishDirectTransportInitialization(wrapper)'.

	! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 15:06'!
primStartReceiving

	| receiver wrapperOop wrapper |
	self var: 'wrapper' type: 'DirectTransportWrapper*'.
	self export: true.
	self inline: false.

	receiver _ interpreterProxy stackObjectValue: 0.
	wrapperOop _ interpreterProxy
		fetchPointer: 0
		ofObject: receiver.
	wrapper _ self wrapperValueOf: wrapperOop.

	self cCode: 'DirectTransportStartReceiving(wrapper)'.

	! !

!DirectTransportPlugin methodsFor: 'as yet unclassified' stamp: 'bvs 12/3/2003 13:34'!
wrapperValueOf: wrapperPointer

	self returnTypeC: 'DirectTransportWrapper*'.
	self static: false.

	^ interpreterProxy firstIndexableField: wrapperPointer! !

TestCase subclass: #DotNetGlobalAccessTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Basic Tests'!

!DotNetGlobalAccessTest commentStamp: 'bvs 10/16/2003 10:27' prior: 0!
Tests global access to the .NET bridge.

NOTE: these tests are dangerous to run if you are using global access; their tearDowns will close the global bridge and so you would lose any live .NET instances that you had.
!

!DotNetGlobalAccessTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/16/2003 10:26'!
tearDown

	DotNet exitDotNet.! !

!DotNetGlobalAccessTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/16/2003 10:22'!
testAccessAfterInstanceExits

	DotNet ArrayList new. "an access before exiting"
	DotNet exitDotNet.
	
	self should: [DotNet ArrayList new count = 0].! !

!DotNetGlobalAccessTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/16/2003 10:17'!
testAccessThroughDotNetClass

	self should: [DotNet ArrayList new count = 0].! !

!DotNetGlobalAccessTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/16/2003 10:25'!
testLoadingLibraries

	| failedAppropriately |
	failedAppropriately _ false.
	
	[DotNet Form new]
		on: MessageNotUnderstood
		do: [failedAppropriately _ true].

	self should: [failedAppropriately]. "not loaded yet"

	DotNet loadLibrary: 'System.Windows.Forms'.

	DotNet Form new.
	self should: [true]. "loaded now"! !

TestCase subclass: #DotNetTestCase
	instanceVariableNames: 'dotNet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Tests Support'!

DotNetTestCase subclass: #CoreBridgeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

!CoreBridgeTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 09:46'!
isAbstract

	^ self sunitName = #CoreBridgeTest! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 13:03'!
testAddStringToArrayList

	| arrayList |
	arrayList _ dotNet System Collections ArrayList new.

	arrayList Add: 'hello'.
	
	self should: [arrayList Count = 1].
	self should: [(arrayList at: 0) = 'hello'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 13:53'!
testArrays

	| arrayList array result |
	arrayList _ dotNet ArrayList new.
	arrayList add: 'hello'.
	arrayList add: 'world'.

	array _ arrayList toArray: dotNet String.

	self should: [array Length = 2]. "length"
	self should: [(array at: 0) = 'hello']. "first element"
	self should: [(array at: 1) = 'world']. "second element"

	result _ array
		at: 1
		put: 'goodbye'.

	self should: [(array at: 1) = 'goodbye']. "after set"
	self should: [result = 'goodbye']. "result of assignment"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 09:18'!
testBlockingCalls

	| started listener |
	started _ false.
	[listener _ dotNet TcpListener new: 0.
	started _ true.
	[listener acceptSocket]
		on: DotNetException
		do: [:exception | ]] newProcess resume.

	[started] whileFalse: [(Delay forMilliseconds: 100) wait].

	self should: [dotNet ArrayList new Count = 0]. "can run calls while blocked"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 11:37'!
testCallBackToDotNetInsideEventHandler

	| textBox latestText |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	textBox _ dotNet TextBox new.
	latestText _ ''.
	textBox TextChanged add: [latestText _ textBox Text].

	textBox Text: 'hello'.
	self should: [latestText = 'hello'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 13:02'!
testCallOnReturnedObject

	| arrayList clone |
	arrayList _ dotNet System Collections ArrayList new.

	arrayList Add: 'hello'.
	clone _ arrayList Clone.

	self should: [clone Count = 1].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/14/2003 22:43'!
testCallbackFromNewDotNetThread

	"This can also happen if the bridge tries
	to Invoke a method on a Control that wasn't
	created from Smalltalk."

	| result |
	result _ nil.
	(dotNet Thread new: [result _ 'result']) Start.

	(Delay forSeconds: 4) wait.

	self should: [result notNil].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 11:35'!
testCaseInsensitiveEvents

	| button clicked |
	dotNet loadLibrary: 'System.Windows.Forms'.

	button _ dotNet Button new.

	clicked _ false.
	button cLiCk add: [clicked _ true].

	button performClick.

	self should: [clicked].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/10/2003 13:47'!
testCaseInsensitiveNamespace

	self should: [dotNet sySTem name = 'sySTem'].
	self should: [dotNet systeM coLLections name = 'systeM.coLLections'].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:23'!
testCaseInsensitiveStaticField

	| ldArg |
	ldArg _ dotNet OpCodes lDaRg.

	self should: [ldArg Name = 'ldarg'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:19'!
testCaseInsensitiveStaticMethod

	| arrayList |
	arrayList _ dotNet System Collections ArrayList repEat: 'hello' with: 3.

	self should: [arrayList Count = 3]. "list count"
	self should: [(arrayList at: 1) = 'hello']. "middle item"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:20'!
testCaseInsensitiveStaticProperty

	| exitCode |
	dotNet System Environment exItCode: 300.
	exitCode _ dotNet System Environment eXitCode.

	self should: [exitCode = 300].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:26'!
testCaseInsensitiveTypeNames

	| arrayList exitCode |
	arrayList _ dotNet sysTem coLlections arrAyList new.
	self should: [arrayList Count = 0]. "ArrayList new".

	dotNet sYstem envIronment ExitCode: 300.
	exitCode _ dotNet System Environment ExitCode.

	self should: [exitCode = 300]. "Environment ExitCode"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:11'!
testCaseInsensitivity

	| arrayList |
	arrayList _ dotNet System Collections ArrayList new.

	arrayList add: 'hello'.
	self should: [arrayList couNt = 1].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/16/2003 10:51'!
testCodeForNewDotNetThreadRunOnThatThread

	| recordedThread dotNetThread |
	recordedThread _ nil.
	dotNetThread _ dotNet Thread new: [recordedThread _ dotNet Thread currentThread].
	dotNetThread start.

	[recordedThread isNil] whileTrue: [(Delay forMilliseconds: 100) wait].

	self should: [recordedThread == dotNetThread].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:14'!
testConstructorsWithParameters

	| innerException outerException |

	innerException _ dotNet System Exception new: 'inner'.
	self should: [innerException Message = 'inner']. "one-parameter constructor"

	outerException _ dotNet System Exception new: 'outer' with: innerException.
	self should: [outerException Message = 'outer']. "two-parameter: first"
	self should: [outerException InnerException Message = 'inner']. "two-parameter: second"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:28'!
testCreateArray

	| array |
	array _ dotNet Int32 Array new: 2.

	self should: [array Length = 2].
	
	array at: 0 put: 34.
	array at: 1 put: 27.

	self should: [(array at: 0) = 34]. "first element"
	self should: [(array at: 1) = 27]. "second element"

	[array at: 0 put: 'hello']
		on: DotNetException
		do:
			[:exception |
			self should: [exception Message = 'Object cannot be stored in an array of this type.'].
			^self].

	self should: [false]. "expected exception"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:38'!
testCreateGraphicsOnShownForm

	| form done |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	form _ dotNet Form new.
	form Show.

	done _ false.
	[form CreateGraphics.
	done _ true] newProcess resume.

	(Delay forSeconds: 2) wait.

	self should: [done].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 12:06'!
testCreateSizeWithoutNamespaces

	"This didn't work in a test for another program.
	Windows Forms contains a type whose short name is
	SIZE.  If the Drawing assembly is searched after the
	Forms assembly, the SIZE type could accidentally
	be found."

	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.
	dotNet Assembly LoadWithPartialName: 'System.Drawing'.

	self should: [(dotNet Size new: 50 with: 50) width = 50].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 15:43'!
testDelegates

	| form button applicationProcess eventHandlerProcess |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	form _ nil.
	button _ nil.
	applicationProcess _ nil.
	[form _ dotNet Form new.
	
	button _ dotNet Button new.
	form Controls Add: button.

	applicationProcess _ Processor activeProcess.
	dotNet Application Run: form] newProcess resume.

	[form isNil or: [form Visible not]] whileTrue: [(Delay forMilliseconds: 100) wait].

	eventHandlerProcess _ nil.
	button Click add: [eventHandlerProcess _ Processor activeProcess].

	form Invoke: [button performClick].

	[self should: [applicationProcess == eventHandlerProcess]] ensure:
		[form invoke: [form dispose]].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/16/2003 12:08'!
testDelegatesThatReturnAValue

	| delegate |
	delegate _ dotNet TypeFilter new:
		[:type :filterCriteria | type FullName = 'System.Collections.ArrayList'].

	self should:
		[delegate
			invoke: dotNet ArrayList
			with: nil].

	self shouldnt:
		[delegate
			invoke: dotNet Hashtable
			with: nil].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:34'!
testDotNetTypeAsParameter

	| typeArray |
	typeArray _ dotNet Type Array new: 1.
	typeArray at: 0 put: dotNet ArrayList.

	self should: [(typeArray at: 0) FullName = 'System.Collections.ArrayList'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:33'!
testDotNetTypeUsedAsTypeObject

	self should: [dotNet ArrayList FullName = 'System.Collections.ArrayList'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/21/2003 12:02'!
testEnumerateUsingExplicitInterfaceImplementation

	"This failed in one of our internal applications.
	ListBox's items enumerator uses explicit interface
	implementation methods - IEnumerator.MoveNext and
	so forth instead of just MoveNext - and our method
	lookup was not finding them.

	Furthermore: the enumerator had a 'current' field
	that was hiding the Current property in one of
	our lookup schemes."

	| listBox items |
	dotNet loadLibrary: 'System.Windows.Forms'.
	listBox _ dotNet ListBox new.

	listBox items add: 'One'.
	listBox items add: 'Two'.
	listBox items add: 'Three'.

	items _ OrderedCollection new.
	listBox items do: [:each | items add: each].
	
	self should: [items asArray = #('One' 'Two' 'Three')].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 12:10'!
testEnumeratedTypes

	| openMode |
	openMode _ dotNet System IO FileMode Open.

	self should: [openMode ToString = 'Open']. "string value"
	self should: [openMode GetType FullName = 'System.IO.FileMode']. "type"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 12:11'!
testEnumeratedTypesIgnoreCase

	| openMode |
	openMode _ dotNet System IO FileMode opEn.

	self should: [openMode ToString = 'Open']. "string value"
	self should: [openMode GetType FullName = 'System.IO.FileMode']. "type"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:03'!
testEnumeration

	| arrayList upperCase |
	arrayList _ dotNet ArrayList new.
	arrayList Add: 'hello'.
	arrayList Add: 'world'.

	upperCase _ arrayList collect: [:each | each asUppercase].

	self should: [(upperCase at: 0) = 'HELLO'].
	self should: [(upperCase at: 1) = 'WORLD'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:08'!
testEnumerationOfArray

	| arrayList array upperCase |
	arrayList _ dotNet ArrayList new.
	arrayList Add: 'hello'.
	arrayList Add: 'world'.

	array _ arrayList toArray: dotNet String.

	upperCase _ array collect: [:each | each asUppercase].

	self should: [(upperCase at: 0) = 'HELLO'].
	self should: [(upperCase at: 1) = 'WORLD'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 10:24'!
testEnumerationOfEnumerable

	| doc |
	dotNet loadLibrary: 'System.Xml'.
	doc _ dotNet XmlDocument new.

	self
		shouldnt: [doc do: [:each]]
		raise: MessageNotUnderstood
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 15:41'!
testErrorInsideEventHandlerFreesDotNetBlockedCalls

	| form callCount done |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	form _ nil.
	[form _ dotNet Form new.
	dotNet Application run: form] newProcess resume.
	
	[form isNil or: [form visible not]] whileTrue: [(Delay forMilliseconds: 100) wait].

	callCount _ 0.
	form TextChanged add:
		[callCount _ callCount + 1.
		self error: ''].

	done _ false.
	[[form invoke: [form Text: 'some text']]
		on: Error
		do: [:exception | done _ true]] newProcess resume.

	(Delay forSeconds: 2) wait.

	[self should: [done]] ensure: [form invoke: [form Dispose]].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 13:45'!
testErrorsInsideEventHandler

	| button errorFromInsideHandler |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	button _ dotNet Button new.

	errorFromInsideHandler _ nil.
	button Click add:
		[errorFromInsideHandler _ Error new.
		errorFromInsideHandler signal].

	[button PerformClick]
		on: Error
		do:
			[:exception |
			self should: [exception == errorFromInsideHandler]. "received error"
			
			button Text: 'button text'.
			self should: [button Text = 'button text']. "button still operational from same thread"

			^self].

	self should: [false]. "expected error"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 09:20'!
testEventDelegates

	| button clickCount |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	button _ dotNet Button new.

	clickCount _ 0.
	button Click add: [clickCount _ clickCount + 1].

	button PerformClick.
	self should: [clickCount = 1]. "first click"
	
	button PerformClick.
	self should: [clickCount = 2]. "second click"
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/24/2003 13:06'!
testEventHandlerRemoval

	| button count handler |
	dotNet loadLibrary: 'System.Windows.Forms'.
	button _ dotNet Button new.

	count _ 0.
	handler _ [count _ count + 1].

	button click add: handler.
	button performClick.

	button click remove: handler.
	button performClick.

	self should: [count = 1].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:32'!
testEventHandlersOkWhenGarbageIsCollected

	| button clickCount |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	button _ dotNet Button new.
	
	clickCount _ 0.
	button Click add: [clickCount _ clickCount + 1].

	Smalltalk garbageCollect.

	button PerformClick.
	self should: [clickCount = 1].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:04'!
testField

	| header |
	header _ dotNet System Runtime Remoting Messaging Header new: 'name' with: 'value'.

	self should: [header Name = 'name'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:12'!
testFieldCaseInsensitivity

	| header |
	header _ dotNet System Runtime Remoting Messaging Header new: 'name' with: 'value'.

	header nAmE: 'other name'.

	self should: [header nAme = 'other name'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:10'!
testFieldSetting

	| header |
	header _ dotNet System Runtime Remoting Messaging Header new: 'name' with: 'value'.

	header Name: 'other name'.

	self should: [header Name = 'other name'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 15:41'!
testGetTextFromShowingTextBox

	| form textBox |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	form _ dotNet Form new.
	
	textBox _ dotNet TextBox new.
	textBox Text: 'hello'.

	form Controls Add: textBox.

	[dotNet Application Run: form] newProcess resume.
	(Delay forSeconds: 2) wait.

	[self should: [textBox Text = 'hello']] ensure: [form invoke: [form Dispose]].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 15:41'!
testGetTextInsideCallbackForShowingTextBox

	| textBox latestText form |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	textBox _ dotNet TextBox new.
	latestText _ ''.
	textBox TextChanged add: [latestText _ textBox Text].

	form _ dotNet Form new.
	form Controls Add: textBox.

	[dotNet Application Run: form] newProcess resume.
	(Delay forSeconds: 2) wait.

	textBox Text: 'hello'.

	[self should: [latestText = 'hello']] ensure: [form invoke: [form Dispose]].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/21/2003 23:51'!
testIndexersNamedOtherThanItem

	"Thanks to Rolf Gebauer for the idea for this test
	and for the code to make it work.  StringBuilder's
	indexer is named Chars, not Item."

	| builder |
	builder _ dotNet StringBuilder new: 'hello'.

	self should: [(builder at: 1) = $e].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/19/2003 19:57'!
testIndexersNamedOtherThanItemSetting

	| builder |
	builder _ dotNet StringBuilder new: 'hello'.
	builder
		at: 1
		put: (dotNet Char parse: 'u').

	self should: [builder toString = 'hullo'].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/14/2003 11:09'!
testInstanceMethodOnTypeType

	"See the comment in #testInstancePropertyOnTypeType."

	self should: [(dotNet Type GetEvent: 'foo') isNil].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/14/2003 11:08'!
testInstancePropertyOnTypeType

	"At the time of this writing, static methods masquerade
	as instance methods of Type objects.  The double-lookup
	could fail if the Type object was the Type object for System.Type."

	self should: [dotNet Type FullName = 'System.Type'].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/10/2003 13:46'!
testInvalidNamespaceRaisesNameError

	[dotNet System2.
	self should: [false]. "expected error"]
		on: MessageNotUnderstood
		do: [:exception | ]
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/19/2003 14:41'!
testIsAlive

	self should: [dotNet isAlive].

	dotNet exitDotNet.

	self shouldnt: [dotNet isAlive].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 12:00'!
testLoadNonSystemStandardLibrary

	dotNet loadLibrary: 'System.Windows.Forms'.

	self should: [dotNet TextBox new Text = ''].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/16/2003 12:09'!
testLookForTypeAfterMakingADelegate

	"Looking for a type in a dynamic assembly using
	GetExportedTypes was causing problems.
	Looking for an unknown type here makes sure
	that the dynamic assembly is searched."

	dotNet ThreadStart new: [self methodThatIsNotThere].

	[dotNet TypeThatIsNotThere.
	self should: [false]. "expected error"]
		on: MessageNotUnderstood
		do: [:exception | ]
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/14/2003 22:42'!
testMakeDotNetCallsInsideNewDotNetThread

	| result |
	result _ nil.
	(dotNet Thread new: [result _ dotNet ArrayList new]) start.

	(Delay forSeconds: 4) wait.

	self should: [result Count = 0]. "result is new ArrayList"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 10:58'!
testMissingMember

	| arrayList |
	arrayList _ dotNet System Collections ArrayList new.
	
	[arrayList notThere]
		on: MessageNotUnderstood
		do:
			[:exception |
			self should: [exception message selector asString = 'notThere'].
			^self].

	self should: [false]. "expected an exception"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 11:16'!
testMissingMemberOnEnumeratedTypes

	| fileModeType mode |
	fileModeType _ dotNet System IO FileMode.

	[mode _ fileModeType notThere]
		on: MessageNotUnderstood
		do:
			[:exception |
			self should: [exception message selector asString = 'notThere'].
			^self].

	self should: [false]. "expected an exception"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 11:14'!
testMissingMemberOnExceptions

	| firstException |
	firstException _ dotNet System Exception new.

	[firstException notThere]
		on: MessageNotUnderstood
		do:
			[:exception |
			self should: [exception message selector asString = 'notThere'].
			^self].

	self should: [false]. "expected an exception"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 11:10'!
testMissingMemberOnStatics

	| arrayListClass |
	arrayListClass _ dotNet System Collections ArrayList.

	[arrayListClass notThere]
		on: MessageNotUnderstood
		do:
			[:exception |
			self should: [exception message selector asString = 'notThere'].
			^self].

	self should: [false] "expected an exception"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:43'!
testMouseEvents

	| button mousedOver |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	button _ dotNet Button new.
	
	mousedOver _ false.
	button MouseMove add: [mousedOver _ true].

	button OnMouseMove: (dotNet MouseEventArgs
		new: dotNet MouseButtons Left
		with: 0
		with: 0
		with: 0
		with: 0).

	self should: [mousedOver].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/18/2003 15:54'!
testMultiLevelNamespacesDifferentiate

	| reflectionLabel formsLabel |
	dotNet loadLibrary: 'System.Windows.Forms'.

	reflectionLabel _ dotNet System Reflection Emit Label.
	formsLabel _ dotNet System Windows Forms Label.

	self should: [reflectionLabel fullName = 'System.Reflection.Emit.Label'].
	self should: [formsLabel fullName = 'System.Windows.Forms.Label'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/16/2003 12:09'!
testNameErrorInsideDelegate

	| delegate |
	delegate _ dotNet ThreadStart new: [self methodThatIsNotThere].

	[delegate invoke]
		on: MessageNotUnderstood
		do: [^self].

	self should: [false]. "expected error"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/10/2003 16:46'!
testNewArrayListEmpty

	| arrayList |

	arrayList _ dotNet System Collections ArrayList new.
	self should: [arrayList Count = 0]! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:35'!
testNewOnTypeObjects

	| arrayList |
	arrayList _ (dotNet Type GetType: 'System.Collections.ArrayList') new.

	self should: [arrayList Count = 0].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 13:08'!
testObjectAsParameter

	| one two |

	one _ dotNet System Collections ArrayList new.
	one Add: 'a'.
	one Add: 'b'.

	two _ dotNet System Collections ArrayList new.
	two Add: 'c'.

	one AddRange: two.

	self should: [one Count = 3].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:45'!
testPaintEvents

	| button painted eventArgs |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	button _ dotNet Button new.

	painted _ false.
	button Paint add: [painted _ true].

	eventArgs _ dotNet PaintEventArgs
		new: button CreateGraphics
		with: (dotNet Rectangle
			new: 0
			with: 0
			with: 0
			with: 0).

	button OnPaint: eventArgs.

	self should: [painted].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/13/2003 14:48'!
testParametersToEvents

	| recordedSender recordedEventArgs button |
	dotNet Assembly LoadWithPartialName: 'System.Windows.Forms'.

	recordedSender _ nil.
	recordedEventArgs _ nil.

	button _ dotNet Button new.
	button Click add:
		[:sender :eventArgs |
		recordedSender _ sender.
		recordedEventArgs _ eventArgs].

	button performClick.

	self should: [dotNet Object ReferenceEquals: button with: recordedSender]. "sender was button"
	self should: [recordedEventArgs GetType FullName = 'System.EventArgs']. "event args"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 10:23'!
testPrintingDotNetObjects

	"At the time of this writing, DotNetObjects extend Collection to inherit
	enumeration behavior.  Some of them can't be used as Collections, and
	so have trouble with Collection's #printOn: method."

	| form |
	dotNet loadLibrary: 'System.Windows.Forms'.

	form _ dotNet Form new.
	self should: [form printString = form toString].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 13:29'!
testPropertySetting

	| arrayList |

	arrayList _ dotNet System Collections ArrayList new.

	arrayList Capacity: 100.
	self should: [arrayList Capacity = 100].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:17'!
testProtectedMethod

	| arrayList clone |
	arrayList _ dotNet ArrayList new.
	clone _ arrayList MemberwiseClone.

	self should: [clone Count = 0].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 12:03'!
testResolveTypesWithoutNamespaces

	| arrayList |
	arrayList _ dotNet ArrayList new.

	self should: [arrayList Count = 0].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 12:04'!
testResolveTypesWithoutNamespacesIgnoresCase

	| arrayList |
	arrayList _ dotNet arrAylist new.
	
	self should: [arrayList Count = 0].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:21'!
testStaticField

	| ldArg |
	ldArg _ dotNet OpCodes Ldarg.

	self should: [ldArg Name = 'ldarg'].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:15'!
testStaticMethod

	| arrayList |
	arrayList _ dotNet System Collections ArrayList Repeat: 'hello' with: 3.

	self should: [arrayList Count = 3]. "list count"
	self should: [(arrayList at: 1) = 'hello']. "middle item"! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 22:17'!
testStaticProperty

	| exitCode |
	dotNet System Environment ExitCode: 300.
	exitCode _ dotNet System Environment ExitCode.

	self should: [exitCode = 300].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/14/2003 14:01'!
testStringsLongerThanOneLine

	| arrayList string |
	arrayList _ dotNet ArrayList new.

	string _ 'a string', String crlf, 'on two lines'.
	arrayList add: string.

	self should: [(arrayList at: 0) = string].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/12/2003 12:09'!
testStringsThatStartAndEndWithSpace

	| arrayList string |
	arrayList _ dotNet ArrayList new.

	string _ '   a string   '.
	arrayList Add: string.

	self should: [(arrayList at: 0) = string].! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/17/2003 15:41'!
testTwoDotNetThreads

	| form result |
	dotNet loadLibrary: 'System.Windows.Forms'.

	form _ nil.
	(dotNet Thread new:
		[form _ dotNet Form new.
		dotNet Application run: form]) start.

	result _ nil.
	(dotNet Thread new: [result _ 3]) start.

	[form isNil or: [result isNil]] whileTrue: [(Delay forMilliseconds: 100) wait].

	form invoke: [form dispose].
	self should: [result = 3].
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/15/2003 22:34'!
testTypeObjectIdentity

	self should: [dotNet ArrayList == dotNet ArrayList]. "same object"
! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'jrp 8/3/2004 14:28'!
testUsingSelfDo

	| message reader |
	(dotNet StringReader new: 'Hello Bob') usingSelfDo: [:me | message _ me readLine. reader _ me].
	
	self should: [message = 'Hello Bob'].
	self should: [reader readLine] raise: DotNetException.
	
	! !

!CoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/11/2003 13:07'!
testVoidMethod

	| arrayList result |

	arrayList _ dotNet System Collections ArrayList new.
	
	arrayList Add: 'hello'.
	arrayList Add: 'there'.

	result _ arrayList Reverse.

	self should: [result isNil]. "result of void method is nil"
	self should: [(arrayList at: 0) = 'there']. "list reversed"! !

CoreBridgeTest subclass: #DotNetDirectCoreBridgeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectCoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:13'!
createDotNet

	^ DotNet startNewDirect
! !

CoreBridgeTest subclass: #DotNetSocketsCoreBridgeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsCoreBridgeTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets! !

DotNetTestCase subclass: #DotNetDirectStressTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectStressTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/5/2003 09:57'!
createDotNet

	^ DotNet startNewDirect
! !

!DotNetDirectStressTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/5/2003 10:15'!
testWaitForSignalThroughTimeout

	"As of this writing (12/5/2003), the direct bridge uses sockets to signal
	when data is ready to be received.  Reading the signal byte from a
	socket can timeout, but that timeout shouldn't affect whether the
	system stays alive."

	| form returned |

	dotNet loadLibrary: 'System.Windows.Forms'.

	returned _ false.

	[form _ dotNet Form new.
	dotNet Application run: form.
	returned _ true] newProcess resume.

	(Delay forSeconds: 60) wait.
	form invoke: [form dispose].

	self should: [returned].
! !

DotNetTestCase subclass: #DotNetExceptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

DotNetExceptionsTest subclass: #DotNetDirectExceptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:13'!
createDotNet

	^ DotNet startNewDirect! !

!DotNetExceptionsTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:11'!
isAbstract

	^ self sunitName = #DotNetExceptionsTest
! !

!DotNetExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/5/2003 08:57'!
testExceptionMessageText

	"Squeak uses #messageText to display exceptions."

	| arrayList |
	arrayList _ dotNet System Collections ArrayList new.
	
	[arrayList at: 1.
	self should: [false]. "should have raised exception"]
		on: DotNetException
		do: [:exception |
			self should: [exception messageText = exception Message]].! !

!DotNetExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/5/2003 08:57'!
testExceptions

	| arrayList |
	arrayList _ dotNet System Collections ArrayList new.
	
	[arrayList at: 1.
	self should: [false]. "should have raised exception"]
		on: DotNetException
		do: [:exception |
			self should: [exception Message = ('Index was out of range.  Must be non-negative and less than the size of the collection.', String crlf, 'Parameter name: index')]].! !

!DotNetExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/5/2003 08:57'!
testExceptionsOnCallsToExceptions

	| firstException |
	[firstException _ dotNet System Exception new.
	firstException GetObjectData: nil with: nil.
	self should: [false]. "should have raised exception"]
		on: DotNetException
		do:
			[:exception |
			self should: [exception Message = ('Value cannot be null.', String crlf, 'Parameter name: info')]]! !

!DotNetExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/5/2003 08:58'!
testExceptionsOnConstructors

	| arrayList |
	[arrayList _ dotNet System Collections ArrayList Repeat: 'hello' with: -1.
	self should: [false]. "should have raised exception"]
		on: DotNetException
		do:
			[:exception |
			self should: [exception Message = ('Non-negative number required.', String crlf, 'Parameter name: count')]].! !

!DotNetExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/11/2003 13:59'!
testResumeMNUInsideCallbackFromOutsideCallback

	| button target result |
	true ifTrue: [^ self]. "not implemented yet - planning to do post R3"

	dotNet loadLibrary: 'System.Windows.Forms'.

	button _ dotNet Button new.
	
	target _ Object new.
	result _ nil.
	button click add: [result _ target notThere].

	[button performClick]
		on: MessageNotUnderstood
		do: [:exception | exception resume: 3].

	self should: [result = 3].
! !

!DotNetExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/11/2003 14:01'!
todo

	"Exceptions while using the bridge don't really work the way that Squeak
	exceptions should - they unwind the stack like .NET exceptions.  While some
	unwinding is probably inevitable, #testResumeMNUInsideCallbackFromOutsideCallback
	is a start at remedying this behavior (although it isn't implemented yet)."
! !

DotNetExceptionsTest subclass: #DotNetSocketsExceptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsExceptionsTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets! !

DotNetTestCase subclass: #DotNetGCStressTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

DotNetGCStressTest subclass: #DotNetDirectGCStressTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectGCStressTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:15'!
createDotNet

	^ DotNet startNewDirect! !

!DotNetGCStressTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:14'!
isAbstract

	^ self sunitName = #DotNetGCStressTest! !

!DotNetGCStressTest methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 12:57'!
testGarbageCollectionDuringManyObjectCreations

	| workerProcess timeElapsed |
	workerProcess _ [10000 timesRepeat: [dotNet ArrayList new]] newProcess.

	[workerProcess resume.

	timeElapsed _ 0.
	[workerProcess isTerminated not and: [timeElapsed < 60000]] whileTrue:
		[(Delay forMilliseconds: 100) wait.
		timeElapsed _ timeElapsed + 100]] ensure: [workerProcess terminate].

	self should: [timeElapsed < 60000].
! !

DotNetGCStressTest subclass: #DotNetSocketsGCStressTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsGCStressTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets! !

DotNetTestCase subclass: #DotNetGCTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

DotNetGCTest subclass: #DotNetDirectGCTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectGCTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:19'!
createDotNet

	^ DotNet startNewDirect
! !

!DotNetGCTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:18'!
isAbstract

	^ self sunitName = #DotNetGCTest! !

!DotNetGCTest methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 10:42'!
testDotNetObjectGarbageGetsCollected

	| originalCount |
	Smalltalk garbageCollect.
	originalCount _ DotNetObject allInstances size.

	dotNet ArrayList new.

	Smalltalk garbageCollect.

	self should: [DotNetObject allInstances size = originalCount]. "garbage collected on Squeak side"
	self should: [dotNet internalDotNetObjectCount = originalCount]. "internal tables cleaned up"
! !

!DotNetGCTest methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 10:32'!
testObjectsAvailableAgainAfterGc

	"Objects whose proxies are collected should be available
	if they're re-returned from .NET"

	self should: [dotNet ArrayList new count = 0].

	Smalltalk garbageCollect.

	self should: [dotNet ArrayList new count = 0].
! !

DotNetGCTest subclass: #DotNetSocketsGCTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsGCTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets
! !

DotNetTestCase subclass: #DotNetIntrospectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

DotNetIntrospectionTest subclass: #DotNetDirectIntrospectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectIntrospectionTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:20'!
createDotNet

	^ DotNet startNewDirect! !

!DotNetIntrospectionTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:20'!
isAbstract

	^ self sunitName = #DotNetIntrospectionTest! !

!DotNetIntrospectionTest methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 09:45'!
testCallMethodsOnDotNetSide

	self shouldnt: [dotNet dotNetSide stopped].
	self should: [dotNet ArrayList new count = 0]. "other stuff still works"
	self shouldnt: [dotNet dotNetSide stopped]. "works twice"! !

DotNetIntrospectionTest subclass: #DotNetSocketsIntrospectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsIntrospectionTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets! !

DotNetTestCase subclass: #DotNetPrimitivesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

DotNetPrimitivesTest subclass: #DotNetDirectPrimitivesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:13'!
createDotNet

	^ DotNet startNewDirect
! !

!DotNetPrimitivesTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 09:26'!
isAbstract

	^ self sunitName = #DotNetPrimitivesTest! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 09:35'!
setUp

	super setUp.
	dotNet loadLibrary: 'System.Drawing'! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:37'!
testBoolAsParameter

	| arrayList |
	arrayList _ dotNet ArrayList new.
	
	arrayList add: false.
	arrayList add: true.

	self should: [(arrayList at: 0) = false].
	self should: [(arrayList at: 1) = true].! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:36'!
testBoolReturnValue

	| arrayList |
	arrayList _ dotNet ArrayList new.

	self shouldnt: [arrayList contains: 'hello']. "false - before adding"

	arrayList add: 'hello'.
	self should: [arrayList contains: 'hello']. "true - after adding"! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 11/7/2003 12:46'!
testBytes

	| byteArray |
	byteArray _ dotNet Byte Array new: 1.
	byteArray
		at: 0
		put: 200.

	self should: [(byteArray at: 0) = 200].
! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/21/2003 23:46'!
testChars

	| builder |
	builder _ dotNet StringBuilder new: 'hello'.
	self should: [(builder at: 1) = $e].

	builder
		at: 1
		put: $u.

	self should: [builder toString = 'hullo'].

! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:44'!
testDoubleReturnValue

	self should: [(dotNet Math log: 2) = 0.693147180559945].! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/15/2003 21:39'!
testDoublesAsParameters

	| value |
	value _ (dotNet System Math exp: (dotNet System Math log: 2)) asString.
	self should: [value = '2'].
! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:41'!
testFloats

	| pointf |
	pointf _ dotNet PointF
		new: 1.1
		with: 0.5.

	self should: [pointf x = 1.1].
	self should: [pointf y = 0.5].! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/20/2003 12:07'!
testLargeStrings

	"There was a problem in the socket-receiving code that
	caused strings requiring more than one read from the
	socket to time out."

	| longString list |
	longString _ ''
		padded: #right
		to: 5000
		with: $a.

	list _ dotNet ArrayList new.
	list add: longString.
	
	self should: [(list at: 0) = longString].
! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/15/2003 16:13'!
testLongs

	self should: [(dotNet System Math abs: 4000000000) = 4000000000].
	self should: [(dotNet System Math abs: SmallInteger maxVal) = SmallInteger maxVal].
	self should: [(dotNet System Math abs: SmallInteger maxVal + 1) = (SmallInteger maxVal + 1)].
! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/15/2003 21:46'!
testNegativeIntegers

	self should: [(dotNet Int32 parse: '-43242') = -43242].
! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:34'!
testNullReturnValue

	| objectType baseType |
	objectType _ dotNet Object new getType.
	baseType _ objectType baseType.

	self should: [baseType isNil]. "Object's base type is null"! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/15/2003 21:42'!
testOtherIntegerTypes

	self should: [(dotNet Int16 parse: '-1') = -1].
	self should: [(dotNet Byte parse: '1') = 1].
	self should: [(dotNet SByte parse: '-1') = -1].

	self should: [(dotNet UInt16 parse: '1') = 1].
	self should: [(dotNet UInt32 parse: '1') = 1].
	self should: [(dotNet UInt64 parse: '1') = 1].
! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:35'!
testPassNilToMethodsThatDontTakeObject

	| stringCollection |
	stringCollection _ dotNet StringCollection new.
	stringCollection add: nil.

	self should: [stringCollection Count = 1]. "has one item"
	self should: [(stringCollection at: 0) isNil]. "the item is nil"! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:43'!
testRoundNumberFloats

	| pointf |
	pointf _ dotNet PointF
		new: 1.0
		with: 0.0.

	self should: [pointf x = 1.0].
	self should: [pointf y = 0.0].! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:31'!
testStrings

	self should: ['Monday' = dotNet DayOfWeek Monday toString]! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:33'!
testStringsThatEndWithNewline

	"Printing to a socket could possibly confuse newlines in the string
	with newlines used in the wire protocol."

	| arrayList string |
	arrayList _ dotNet ArrayList new.

	string _ 'a string', String crlf.
	arrayList add: string.

	self should: [(arrayList at: 0) = string].! !

!DotNetPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:34'!
testZeroLengthStrings

	| arrayList string |
	arrayList _ dotNet ArrayList new.
	string _ ''.
	
	arrayList add: string.

	self should: [(arrayList at: 0) = string].! !

DotNetPrimitivesTest subclass: #DotNetSocketsPrimitivesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsPrimitivesTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets
! !

DotNetTestCase subclass: #DotNetRubyIntegrationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

DotNetRubyIntegrationTest subclass: #DotNetDirectRubyIntegrationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectRubyIntegrationTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:21'!
createDotNet

	^ DotNet startNewDirect! !

!DotNetRubyIntegrationTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:21'!
isAbstract

	^ self sunitName = #DotNetRubyIntegrationTest! !

!DotNetRubyIntegrationTest methodsFor: 'as yet unclassified' stamp: 'bvs 11/13/2003 18:01'!
tearDown

	dotNet Ruby getClient shutdown.
	super tearDown.
! !

!DotNetRubyIntegrationTest methodsFor: 'as yet unclassified' stamp: 'bvs 11/13/2003 18:04'!
testSendMessageToRuby

	self should: [(dotNet Ruby getClient Eval: 'Array.new') length = 0].
! !

DotNetRubyIntegrationTest subclass: #DotNetSocketsRubyIntegrationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsRubyIntegrationTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets! !

DotNetTestCase subclass: #DotNetShutdownTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

DotNetShutdownTest subclass: #DotNetDirectShutdownTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectShutdownTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/12/2003 09:24'!
createDotNet

	^ DotNet startNewDirect
! !

!DotNetShutdownTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/12/2003 09:23'!
isAbstract

	^ self sunitName = #DotNetShutdownTest! !

!DotNetShutdownTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/12/2003 09:29'!
testInternalThreadsStoppedAtExit

	| threadOneStarted threadTwoStarted |
	threadOneStarted _ false.
	threadTwoStarted _ false.

	(dotNet Thread new: [threadOneStarted _ true]) start.
	(dotNet Thread new: [threadTwoStarted _ true]) start.

	[threadOneStarted and: [threadTwoStarted]] whileFalse: [(Delay forMilliseconds: 100) wait].

	dotNet exitDotNet.

	dotNet internalStartedThreadsDo: [:each | self should: [each isTerminated]].! !

!DotNetShutdownTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/12/2003 09:40'!
testThreadsBlockedInDotNetUnblock

	| form exceptionReceived |
	dotNet loadLibrary: 'System.Windows.Forms'.

	exceptionReceived _ false.
	[form _ dotNet Form new.
	[dotNet Application run: form]
		on: Exception
		do: [:exception | exceptionReceived _ true]] newProcess resume.

	[form notNil and: [form visible]] whileFalse: [(Delay forMilliseconds: 100) wait].

	dotNet exitDotNet.

	(Delay forMilliseconds: 100) wait.
	self should: [exceptionReceived].

	! !

DotNetShutdownTest subclass: #DotNetSocketsShutdownTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsShutdownTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/12/2003 09:23'!
createDotNet

	^ DotNet startNewSockets! !

!DotNetTestCase class methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 12:51'!
isAbstract

	^ self sunitName = #DotNetTestCase
! !

!DotNetTestCase methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:24'!
createDotNet

	self subclassResponsibility! !

!DotNetTestCase methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 09:34'!
setUp

	dotNet _ self createDotNet
! !

!DotNetTestCase methodsFor: 'as yet unclassified' stamp: 'bvs 11/5/2003 10:37'!
tearDown

	dotNet exitDotNet
! !

DotNetTestCase subclass: #ExtendDotNetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Abstract Tests'!

ExtendDotNetTest subclass: #DotNetDirectExtendDotNetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Plugin Tests'!

!DotNetDirectExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:23'!
createDotNet

	^ DotNet startNewDirect! !

ExtendDotNetTest subclass: #DotNetSocketsExtendDotNetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Socket Tests'!

!DotNetSocketsExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:31'!
createDotNet

	^ DotNet startNewSockets! !

!ExtendDotNetTest class methodsFor: 'as yet unclassified' stamp: 'bvs 12/4/2003 10:22'!
isAbstract

	^ self sunitName = #ExtendDotNetTest! !

!ExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:19'!
testClientObjectInDotNetCollection

	| list clientObject |
	list _ dotNet ArrayList new.
	clientObject _ Object new.

	list add: clientObject.

	self should: [clientObject == (list at: 0)].! !

!ExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:28'!
testClientObjectInDotNetCollectionSafeAfterGc

	| list |
	list _ dotNet ArrayList new.
	list add: Object new.

	self should: [(list at: 0) notNil].! !

!ExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:27'!
testImplementICollection

	| collection list |
	collection _ ICollectionImplementation new.
	list _ dotNet ArrayList new: collection.

	self should: [list Count = 2]. "two items in ArrayList"
	self should: [(list at: 0) = 'hello']. "first item"
	self should: [(list at: 1) = 'world']. "second item"! !

!ExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/16/2003 09:11'!
testSameDotNetObjectGivesSameSqueakReference

	| list dotNetObject |
	list _ dotNet ArrayList new.
	dotNetObject _ dotNet Object new.

	list add: dotNetObject.

	self should: [(list at: 0) == dotNetObject].
! !

!ExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 10/24/2003 12:30'!
testSameSqueakObjectGivesSameDotNetReference

	| list object |
	list _ dotNet ArrayList new.
	object _ Object new.

	list add: object.

	self should: [list contains: object].
	! !

!ExtendDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 09:18'!
todo

	"This isn't really about extending yet - just object identity and implementing
	.NET interfaces.  There are some Ruby tests that are about implementation
	inheritance."
! !

TestCase subclass: #MessageFromDotNetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Basic Tests'!

!MessageFromDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:34'!
testMultipleParameterConversion

	| message |
	message _ MessageFromDotNet new
		messageName: 'MultiplyAll'
		args: #(2 3 4).

	self should: [message args = #(2 3 4)].
	self should: [message selector = #MultiplyAll:with:with:].! !

!MessageFromDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:32'!
testOneParameterConversion

	| message |
	message _ MessageFromDotNet new
		messageName: 'Store'
		args: #(2).

	self should: [message args = #(2)].
	self should: [message selector = #Store:].! !

!MessageFromDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:38'!
testSpecialBlockValueMessage

	| message |
	message _ MessageFromDotNet new
		messageName: '*'
		args: #(2 3 4).

	self should: [message args = #((2 3 4))]. "args is a one-element list with the passed args"
	self should: [message selector = #valueWithPossibleArgs:].! !

!MessageFromDotNetTest methodsFor: 'as yet unclassified' stamp: 'bvs 9/2/2003 11:30'!
testZeroParameterConversion

	| message |
	message _ MessageFromDotNet new
		messageName: 'Count'
		args: #().

	self should: [message args isEmpty].
	self should: [message selector = #Count].! !

TestCase subclass: #ObjectRegistryTest
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DotNetBridge-Basic Tests'!

!ObjectRegistryTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/29/2003 09:27'!
setUp

	registry _ ObjectRegistry new initialize.! !

!ObjectRegistryTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/29/2003 09:29'!
testObjectIds

	| one two |
	one _ Object new.
	two _ Object new.

	self should: [(registry objectId: one) = (registry objectId: one)].
	self should: [(registry objectId: two) = (registry objectId: two)].
	self shouldnt: [(registry objectId: one) = (registry objectId: two)].
! !

!ObjectRegistryTest methodsFor: 'as yet unclassified' stamp: 'bvs 8/29/2003 09:32'!
testRegisteredObject

	| anObject |
	anObject _ Object new.
	registry
		registerObject: anObject
		withId: 'someId'.

	self should: [(registry objectId: anObject) = 'someId'].! !
DotNetBridgeExternalFile initialize!
